unit UMCUUE;

interface
uses NMUUE, UMCaux, classes, jclfileutils,sysutils;

function UUE_Encode(FileName:string):string;
implementation

uses UMClogger;

function UUE_Encode(FileName:string):string;
var n:TNMUUProcessor;
    ins,outs:tfilestream;
    fn,s,ts:string;
    z:textfile;
begin
    _('UUEENCODE: '+filename);
    if fileexists(filename) then begin
    s:='';
    fn:=GetTPath+Extractfilename(filename)+'.uue';
    ins:=tfilestream.Create(filename,fmOpenRead);
    outs:=tfilestream.Create(fn,fmCreate);
    n:=TNMUUProcessor.Create(nil);
    n.InputStream:=ins;
    n.OutputStream:=outs;
    n.Method:=uuCode;
    n.Encode;
    ins.Free;
    outs.Free;
    n.free;
    assignfile(z,fn);
    reset(z);
    s:='';
    while not eof(z) do begin
        readln(z,ts);
        s:=s+ts+#13#10;
    end;
    s:='begin 777 '+extractfilename(filename)+#13#10+s+#13#10'end'#13#10;
    closefile(z);
    erase(z);
    result:=s;
    end else result:='   '+filename+#13#10;
end;


end.
