unit UMCimframe;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TImageFrame = class(TFrame)
    Graph: TPanel;
    imm: TImage;
    ZoomInG: TPanel;
    ZoomOutG: TPanel;
    SaveGraph: TPanel;
    Timer4: TTimer;
    spd: TSaveDialog;
    procedure ZoomOutGClick(Sender: TObject);
    procedure ZoomInGClick(Sender: TObject);
    procedure SaveGraphClick(Sender: TObject);
    procedure FrameMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FrameMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  public
    needredraw:boolean;
  end;

implementation

uses UMCaux;

{$R *.dfm}

procedure TImageFrame.ZoomOutGClick(Sender: TObject);
begin
    stzoom:=stzoom-1;
    if stZoom<1 then stZoom:=1;
    needredraw:=true;
end;

procedure TImageFrame.ZoomInGClick(Sender: TObject);
begin
    stZoom:=stZoom+1;
    needredraw:=true;

end;

procedure TImageFrame.SaveGraphClick(Sender: TObject);
begin
//    spd.InitialDir:=umcdir;
//    spd.FileName:='UMC '+datetimetostr(now)+'.jpg';
    if spd.Execute then imm.Picture.Bitmap.SaveToFile(spd.FileName);
end;

procedure TImageFrame.FrameMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
    stzoom:=stzoom-1;
    if stZoom<1 then stZoom:=1;
    needredraw:=true;
end;

procedure TImageFrame.FrameMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
    stZoom:=stZoom+1;
    needredraw:=true;
end;

end.
