{$i umc_bld.inc}
const ver='1.5.'+autobld;
      umpprefix='UMP:';

type
  ITBPDataProvider = interface ['{9DD91B89-A551-4180-8A81-2CCF584CD4BF}']
    function GetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function SetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function GetIntValue(ID: Integer): Integer; stdcall;
    function SetIntValueF(ID, Value: Integer): Integer; stdcall;
    function GetIDType(ID: Integer): Integer; stdcall;
    function ItemCount: Integer; stdcall;
    function ExecuteMacro(AMacro: Pointer; MaxLen: Integer; InData, OutData: ITBPDataProvider): HResult; stdcall;
  end;
type
  TBPGetDataProc = function(ID, DataID: Integer; Buf: PChar; BufSize: Integer): Integer; stdcall;

function GetStr(const S: String; B: PChar; BSize: Integer): Integer;
begin
  if (B = nil) or (BSize < 0) then Result := Length(S) else
  try
    if BSize > Length(S) then BSize := Length(S);
    if BSize > 0 then Move(S[1], B[0], BSize);
    Result := BSize;
  except
    Result := 0;
  end;
end;

function TBP_NeedConfig: Integer; stdcall;
begin
  Result := 0;
end;

function TBP_NeedCOM: Integer; stdcall;
begin
  Result := 1;
end;

function TBP_GetStatus: Integer; stdcall;
begin
  Result := 0;
end;

function TBP_GetVersion(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr(Ver, B, BSize);
end;

function TBP_GetName(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr(umpprefix+' '+PackName, B, BSize);
end;

function TBP_GetMacroList(AData: Pointer; ADataSize: Integer): Integer; stdcall;
begin
  Result := GetStr(UMP_macrolist, AData, ADataSize);
end;

function TBP_GetInfo(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr(
  '<HTML>'+
  '<body style="color: rgb(255, 255, 204); background-color: rgb(0, 0, 32);"'+
  'link="#f5fd6c" alink="#66ff99" vlink="#3366ff">'+
  '<h3><font color=red>Useless Macro Pack:'+' '+packname+' ver. '+ver+'</font></h3><h4>(c) Stanislav V. Mikov</h4><hr>'+
  '<font color=red><br></font>Build date: '+autotm+'<br>if you have any questions/suggestions, mail to <a href="mailto:stanislav-@mail.ru">stanislav-@mail.ru</a>'+
  '<hr>'+packname+' exports following macro: '+ump_macrolist+
  '<br></HTML>'


  , B, BSize);
end;

procedure TBP_Initialize; stdcall;
begin
end;

procedure TBP_Finalize; stdcall;
begin
end;
