library UMP_MBM;

uses
    UMCMBM,
    SysUtils;
{$E TBP}

{$R *.res}

const PackName='MBM';

    UMP_macrolist=
    'UMP_MBM_VER'#13#10+
    'MBMSENSORNAME'#13#10+
    'MBMSENSORVAL'#13#10
    ;
    
{$i ump.inc}
function _gc(Params: ITBPDataProvider;strno:integer):char;
var h:char;
begin
    h:=' ';
    params.GetDataByID(strno,@h,1);
    result:=h;
end;

function TBP_ExecMacro(AMacro: Pointer; MaxLen: Integer; Template, Params: ITBPDataProvider): Integer; stdcall;
var CurrentMacro,ResultString:string;
    i,l:integer;

begin
    SetString(CurrentMacro, PChar(AMacro), MaxLen);
    CurrentMacro:=UpperCase(CurrentMacro);
    result:=123257;
    ResultString:='Bad result '+currentmacro;
    if CurrentMacro='UMP_MBM_VER' then
      ResultString:='Useless MacroPack: '+PackName+' '+ver;

    if CurrentMacro = 'MBMSENSORNAME' then
    begin
        ResultString:='---';
        if ReadMBM then begin
            i:=params.GetIntValue(0);
            if not (i in [1..10]) then i:=1;
            case _gc(params,1) of
                'T':ResultString := tempname[i];
                'F':ResultString := fanname[i];
                'V':ResultString := volname[i];
                'C':ResultString := cpuname[i];
            end;
        end;
    end;

    if CurrentMacro = 'MBMSENSORVAL' then
    begin
        ResultString:='---';
        if ReadMBM then begin
            i:=params.GetIntValue(0);
            if not (i in [1..10]) then i:=1;
            case _gc(params,2) of
                'H':l:=3;
                'L':l:=2;
            else
                l:=1;
            end;
            case _gc(params,1) of
                'T':ResultString := inttostr(round(temperature[i,l]));
                'F':ResultString := inttostr(round(fan[i,l]));
                'V':ResultString := format('%.2f',[voltage[i,l]]);
                'C':ResultString := inttostr(round(cpu[i,l]));
            end;

        end;
      Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
    end;


    Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
end;

exports TBP_NeedConfig, TBP_GetStatus, TBP_GetVersion, TBP_GetName,
  TBP_Finalize, TBP_Initialize, {TBP_Setup,} TBP_NeedCOM,
  TBP_GetMacroList, TBP_ExecMacro, TBP_GetInfo;

begin
end.
