library UMP_TEXTUTIL;

uses
    classes,
    dateutils,
    windows,
    SysUtils;
{$E TBP}

{
%UMPDELIVERYTIME -       .     /.
%UMPDELIVERYFROMDATE -           .     /.
%UMPDELIVERYTODATE -           .     /.
%UMPCHARSET -     .     /.
%UMPMAILER -     .     /.
%UMPREPLYTIME -  ,         .
%UMPGETLINKS("Text") -     .   "Text"  ,      .
%UMPCUTHERE -      "-- ".
%UMPKILLCITE("Text",level) -      level  .  level   (     0)  2.
%UMPMKLINK("Text") -    ,     (,  "Test "    Test ).
%UMPCITE("Text","Slogan",nStrings) -     nStrings  (nStrings/2    ,      nStrings),      Slogan. , %UMPCITE(%UMCSTRINGS(1,2,3,4,5,6,7,8),"",4)   :
}

{$R *.res}

const PackName='TextUtils';

    UMP_macrolist=
    'UMP_TU_VER'#13#10+
'UMPDELIVERYTIME'#13#10+
'UMPDELIVERYFROMDATE'#13#10+
'UMPDELIVERYTODATE'#13#10+
'UMPCHARSET'#13#10+
'UMPMAILER'#13#10+
'UMPREPLYTIME'#13#10+
'UMPGETLINKS'#13#10+
'UMPCUTHERE'#13#10+
'UMPKILLCITE'#13#10+
'UMPMKLINK'#13#10+
'UMPCITE'#13#10+
'UMPGETHEADER'#13#10;
{$i ump.inc}
{$i miniutils.inc}
{$i umctextutils.inc}

function TBP_ExecMacro(AMacro: Pointer; MaxLen: Integer; Template, Params: ITBPDataProvider): Integer; stdcall;
var CurrentMacro,ResultString,TempString,TempString2:string;
    i:integer;
//    b:pchar;
    prm,sec,min,hour,day:string;
    TTT:TDateTime;

begin
    SetString(CurrentMacro, PChar(AMacro), MaxLen);
    CurrentMacro:=UpperCase(CurrentMacro);
    result:=123257;
    ResultString:='Bad result '+currentmacro;
    if CurrentMacro='UMP_TU_VER' then
      ResultString:='Useless MacroPack: '+PackName+' ver.'+ver;



    if CurrentMacro='UMPCITE' then
    begin
      TempString2:=_gs(params,0);
      if TempString2='' then TempString2:=_gs(template,tpxText);
      TempString:=_gs(params,1);
      ResultString:=RemoveLines(TempString2,TempString,params.GetIntValue(2));
    end;


    if CurrentMacro='UMPMKLINK' then
        ResultString:=replaceich(_gs(params,0));

    if CurrentMacro='UMPKILLCITE' then
    begin
      ResultString:=_gs(params,0);
      i:=params.GetIntValue(1);
      if _gs(params,1)='' then i:=2;
      ResultString:=KillCite(ResultString,i);
    end;
    if CurrentMacro='UMPCUTHERE' then
    begin
      ResultString :=#13#10'-- ';
      //Result:=118999;
      Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
    end;



    if CurrentMacro='UMPDELIVERYTIME' then begin
        sec:=_gs(params,0);
        if sec='' then sec:='sec';
        min:=_gs(params,1);
        if min='' then min:='m';
        hour:=_gs(params,2);
        if hour='' then hour:='h';
        day:=_gs(params,3);
        if day='' then day:='d';
        ResultString:=SecDelivery(_gs(template,tpxHeaders),sec,min,hour,day);
    end;

    if CurrentMacro='UMPREPLYTIME' then
    begin

        sec:=_gs(params,0);
        if sec='' then sec:='sec';
        min:=_gs(params,1);
        if min='' then min:='m';
        hour:=_gs(params,2);
        if hour='' then hour:='h';
        day:=_gs(params,3);
        if day='' then day:='d';

      ResultString:=SecReply(_gs(template,tpxHeaders),sec,min,hour,day);

      //Result:=118999;
      Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
    end;
    if CurrentMacro='UMPDELIVERYTODATE' then
    begin
    
      ResultString:=_gs(template,tpxHeaders);

      prm:=_gs(params,0);
      if prm='' then
      {$IFNDEF UMP}
      prm:=o[37];
      {$ELSE}
      prm:='n/a';
      {$ENDIF}

      if not Extracttime(GetFirstHeader(ResultString,'Received:'),ttt) then
      ResultString:=prm else ResultString:=datetimetostr(ttt);
    end;
    
    if CurrentMacro='UMPCHARSET' then
        ResultString:=GetCharset(_gs(template,tpxHeaders));

    if CurrentMacro='UMPMAILER' then begin
        prm:=_gs(params,0);
        if prm='' then prm:='<unknown>';
        ResultString:=GetMAILER(_gs(template,tpxHeaders),prm);
    end;

  {  if CurrentMacro='UMPREPLYTIME' then
    begin

        sec:=_gs(params,0);
        if sec='' then sec:='sec';
        min:=_gs(params,1);
        if min='' then min:='m';
        hour:=_gs(params,2);
        if hour='' then hour:='h';
        day:=_gs(params,3);
        if day='' then day:='d';
      ResultString:=SecReply(_gs(template,tpxHeaders),sec,min,hour,day);
    end;       }

    if CurrentMacro='UMPGETLINKS' then
    begin
      ResultString:=_gs(params,0);

      if ResultString='' then ResultString:=_gs(template,tpxText);

      ResultString:=GetLinks(ResultString);

    end;

    if CurrentMacro='UMPGETHEADER' then
    begin

      ResultString:=_gs(template,tpxHeaders);

      TempString:=_gs(params,0);

      ResultString:=GetFirstHeader(ResultString,TempString);
      ResultString:=trim(copy(ResultString,pos(TempString,ResultString)+1+length(TempString),length(ResultString)-pos(TempString,ResultString)-1-length(TempString)));

    end;

    Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
end;

exports TBP_NeedConfig, TBP_GetStatus, TBP_GetVersion, TBP_GetName,
  TBP_Finalize, TBP_Initialize, {TBP_Setup,} TBP_NeedCOM,
  TBP_GetMacroList, TBP_ExecMacro, TBP_GetInfo;

begin
end.
