library UMP_WA;

uses
  SysUtils,
//  Classes,messages,
  UMCwinamp in 'UMCwinamp.pas';
{$E TBP}


{$R *.res}

const PackName='Winamp';

    UMP_macrolist=
    'UMP_WA_VER'#13#10+
    'WAIF'#13#10+
    'WAVER'#13#10+
    'WACH'#13#10+
    'WANP'#13#10+
    'WAEQ'#13#10+
    'WARATE'#13#10+
    'WABITRATE'#13#10+
    'WAPLPOS'#13#10+
    'WAPLLEN'#13#10+
    'WAPOS'#13#10+
    'WASTATUS'#13#10;

{$i ump.inc}

function TBP_ExecMacro(AMacro: Pointer; MaxLen: Integer; Template, Params: ITBPDataProvider): Integer; stdcall;
var CurrentMacro,ResultString:string;
    i,t:integer;
    b:pchar;

begin
    SetString(CurrentMacro, PChar(AMacro), MaxLen);
    CurrentMacro:=UpperCase(CurrentMacro);
    result:=123257;
    ResultString:='Bad result '+currentmacro;
    if CurrentMacro='WAIF' then
    begin
        if wa then i:=0 else i:=1;
        t:=params.GetDataByID(i,nil,-1);
        getmem(b,t);
        params.GetDataByID(i,b,t);
        ResultString:=copy(b,1,t);
    end;

    if CurrentMacro='UMP_WA_VER' then
      ResultString:='Useless MacroPack: Winamp ver.'+ver;

    if CurrentMacro='WAVER' then
      ResultString:=GetWAver;

    if CurrentMacro='WACH' then
      ResultString:=GetWAcht;

    if CurrentMacro='WANP' then
      ResultString:=GetWAtitle;

    if CurrentMacro='WAEQ' then
      ResultString:=Geteq(params.GetIntValue(0));

    if CurrentMacro='WARATE' then
      ResultString:=GetWArate;

    if CurrentMacro='WABITRATE' then
      ResultString:=GetWAbitrate;

    if CurrentMacro='WAPLPOS' then
      ResultString:=GetWAPLpos;

    if CurrentMacro='WAPLLEN' then
      ResultString:=GetWAPLlen;

    if CurrentMacro='WAPOS' then
      ResultString:=GetWAtracklen;

    if CurrentMacro='WASTATUS' then
      ResultString:=GetWAstate;

    Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
end;

exports TBP_NeedConfig, TBP_GetStatus, TBP_GetVersion, TBP_GetName,
  TBP_Finalize, TBP_Initialize, {TBP_Setup,} TBP_NeedCOM,
  TBP_GetMacroList, TBP_ExecMacro, TBP_GetInfo;

begin
end.
