library useless;
{$E TBP}

{$R *.res}


{%ToDo 'useless.todo'}

uses
  Windows,
  winsock,
  SysUtils,
  forms,
  Classes,
  controls,
  dateutils,
  umcinfo in 'umcinfo.pas',
  verinfo in 'verinfo.pas',
  JclSysInfo in 'JclSysInfo.pas',
  JclFileUtils,
  RASinfo in 'RASinfo.pas';

type
  ITBPDataProvider = interface ['{9DD91B89-A551-4180-8A81-2CCF584CD4BF}']
    function GetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function SetDataByID(ID: Integer; B: Pointer; BSize: Integer): Integer; stdcall;
    function GetIntValue(ID: Integer): Integer; stdcall;
    function SetIntValue(ID, Value: Integer): Integer; stdcall;
    function GetIDType(ID: Integer): Integer; stdcall;
    function ItemCount: Integer; stdcall;
    function ExecuteMacro(AMacro: Pointer; MaxLen: Integer; InData, OutData: ITBPDataProvider): HResult; stdcall;
  end;

const   MacroList='UMC'#13#10'UMCVER'#13#10'UMCTIME'#13#10'UMCDRVFREE'#13#10'UMCDRVFREEK'#13#10'UMCDRVFREEM'#13#10'UMCDRVFREEP'+
        #13#10'UMCIZVRAT'#13#10'UMCTRANSLIT'#13#10'UMCTRANSLIT2'#13#10'UMCREPLACECHAR'#13#10'UMCMKLINK'#13#10'UMCXOR'+
        #13#10'UMCCPUSPEED'#13#10'UMCIP'#13#10'UMCMEMLOAD'#13#10'UMCTICKCOUNT'+
        #13#10'UMCMEMTVIRT'#13#10'UMCMEMAVIRT'#13#10'UMCMEMTPAGE'#13#10'UMCMEMAPAGE'#13#10'UMCMEMTPHYS'#13#10'UMCMEMAPHYS'+
        #13#10'UMCUSERNAME'#13#10'UMCCOMPNAME'#13#10'UMCSCREENRES'#13#10'UMCTEMPPATH'#13#10'UMCSYSPATH'#13#10'UMCBATT'+
        #13#10'UMCSTARTUPINFO'#13#10'UMCMOUSEINFO'#13#10'UMCDRVLIST'#13#10'UMCKBD'#13#10'UMCPRN'#13#10'UMCMOUSEPOS'+
        #13#10'UMCTIMELEFT'#13#10'UMCDAYSLEFT'#13#10'UMCCPUNAME'#13#10'UMCCPUNAMEL'#13#10'UMCCPUVENDOR'+
        #13#10'UMCDAYSFROM'#13#10'UMCHOURSFROM'#13#10'UMCMINSFROM'#13#10'UMCFILL'#13#10'UMCCUTON'+
        #13#10'UMCVOLNAME'#13#10'UMCVOLSNUM'#13#10'UMCVOLFS'#13#10'UMCGETIP'+
        #13#10'UMCBIOSNAME'#13#10'UMCBIOSCOPY'#13#10'UMCBIOSINFO'#13#10'UMCBIOSDATE'+
        #13#10'UMCPROCLIST'#13#10'UMCTASKLIST'#13#10'UMCWINVER'+
        #13#10'UMCRCASE'#13#10'UMCSTRINGS'#13#10'UMCREPLACE'+
        #13#10'UMCCITE'#13#10'UMCDELIVERYTIME'#13#10'UMCGETHEADER'#13#10'UMCREVERSE'+
        #13#10'UMCSCREENDEPTH'#13#10'UMCSCREENRRATE'#13#10'UMCCPUTICKS'#13#10'UMCGETLINKS'#13#10'UMCPS'+
        #13#10'UMCKILLCITE'#13#10'UMCCUTHERE'#13#10+
        'UMCGFHISTORY'#13#10'UMCGFCOOKIES'#13#10'UMCGFICACHE'#13#10'UMCGFTEMPLATES'#13#10+
        'UMCGFCFAVORITES'#13#10'UMCGFAPPDATA'#13#10'UMCGFPRINTHOOD'#13#10'UMCGFCAPPDATA'#13#10'UMCGFCDESKTOP'#13#10+
        'UMCGFCSTARTUP'#13#10'UMCGFCPROGRAMS'#13#10'UMCGFCMENU'#13#10'UMCGFFONTS'#13#10'UMCGFNETHOOD'#13#10'UMCGFDESKTOPD'+
        'UMCGFMENU'#13#10'UMCGFSENDTO'#13#10'UMCGFRECENT'#13#10+
        'UMCGFSTARTUP'#13#10'UMCGFFAVORITES'#13#10'UMCGFPERSONAL'#13#10'UMCGFPROGRAMS'#13#10'UMCGFDESKTOP'+
        'UMCGFTEMP'#13#10'UMCGFSYS'#13#10'UMCGFWIN'#13#10'UMCGFPROGRAMFILES'#13#10+
        'UMCGFCURRENT'#13#10'UMCGFCOMMON'#13#10'UMCFILESCOUNT'#13#10'UMCFILESSIZE'+
        #13#10'UMCFILESSIZEK'#13#10'UMCFILESSIZEM'



        ;

//  - ,    GetxxxHeader
// Date  
// false,    
//  ,   Date 
function extracttime(s:string;var Date:tdatetime):boolean;
var i:integer;
    n:tstringlist;

    dd,mm,yy:integer;
    h,m,sc,delta:integer;
    z,z2:tdatetime;

begin
    z2:=date;
    n:=tstringlist.Create;
    while pos(';',s)<>0 do begin
        i:=pos(';',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;
    while pos(',',s)<>0 do begin
        i:=pos(',',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;

    extractstrings([' ',':','/'],[],pchar(s),n);
    dd:=strtoint(n.Strings[0]);
    n.Strings[1]:=lowercase(n.Strings[1]);
    mm:=0;
    case n.Strings[1][1] of
        'f':mm:=2;
        's':mm:=9;
        'o':mm:=10;
        'n':mm:=11;
        'd':mm:=12;
    else
        if n.Strings[1]='jan' then mm:=1;
        if n.Strings[1]='mar' then mm:=3;
        if n.Strings[1]='apr' then mm:=3;
        if n.Strings[1]='jun' then mm:=6;
        if n.Strings[1]='jul' then mm:=7;
        if n.Strings[1]='aug' then mm:=8;
    end;
    yy:=strtoint(n.Strings[2]);
    h:=strtoint(n.Strings[3]);
    m:=strtoint(n.Strings[4]);
    sc:=strtoint(n.Strings[5]);
    if (n.Strings[6]='GMT') or (n.Strings[6]='UMC') then
        delta:=0
    else
        delta:=-strtoint(n.Strings[6]) div 100;
    if yy<2000 then yy:=yy+2000;
    result:=tryencodedatetime(yy,mm,dd,h,m,sc,0,z);
    if result then begin
        z:=inchour(z,delta);
        date:=z;
    end else date:=z2;
    n.Free;
end;
//        hname
//  - headers
//  ,     
function GetFirstHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,j:integer;
    eflag:boolean;
begin
    s:='';
    eflag:=false;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do begin
        if eflag then break;
        if pos(hname,n.Strings[i])=1 then begin
            s:=trim(n.Strings[i]);
            for j:=i+1 to n.Count-1 do
                if n.Strings[j][1]<=' ' then
                s:=s+trim(n.Strings[j]) else
                break;
            eflag:=true;
        end;
    end;

    result:=s;

    n.free;
end;
//  ,   GetFirstHeader,     
function GetLastHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,ii,j:integer;
begin
    s:='';
    ii:=0;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do
        if pos(hname,n.Strings[i])<>0 then ii:=i;

    s:=trim(n.Strings[ii]);
    for j:=ii+1 to n.Count-1 do
       if n.Strings[j][1]=' ' then s:=s+trim(n.Strings[j]) else break;

    result:=s;

    n.free;
end;

function cmpp(a,b:integer):integer;
begin
    if a=0 then result:=b else
    if b=0 then result:=a else
    if a<b then result:=a else result:=b;
end;
function AddFix(text,prefix,suffix:string):string;
var n:tstringlist;
    i:integer;
begin
    n:=tstringlist.Create;
    n.Text:=text;
    for i:=0 to n.Count-1 do
        n.Strings[i]:=prefix+n.Strings[i]+suffix;
    result:=n.Text;
    n.Free;

end;
function KillCite(text:string;clevel:integer):string;
var ts,s:string;
    n:tstringlist;
    i:integer;
begin
    result:=text;
    n:=tstringlist.Create;
    n.Text:=text;
    s:='';
    ts:='';
    for i:=1 to clevel do ts:=ts+'>';
    if ts='' then exit;

    for i:=0 to n.Count-1 do
        if pos(ts,n.Strings[i])=0 then s:=s+n.Strings[i]+#13#10;

    result:=s;
    n.Free;

end;
function GetLinks(Text:string):string;
var s:string;
    i,i1,i2:integer;
begin
    s:='';
    text:=text+'     ';
    for i:=1 to length(text) do if text[i]<' ' then text[i]:=' ';
    repeat
        i1:=pos('http:',LowerCase(text));
        i2:=pos('ftp:',LowerCase(text));
        i:=cmpp(i1,i2);
//        if i1<i2 then i:=i1 else i:=i2;
        if i=0 then break;
        text:=copy(text,i,length(text)-i+1);

        i1:=0;
        for i:=1 to length(text) do
            if not(lowercase(text)[i] in ['a'..'z','!'..'/','~','_','@',':','0'..'9']) then begin
                i1:=i;
                break;
            end;
        if i1=0 then i1:=length(text);

        if s<>'' then s:=s+#13#10;
        s:=s+copy(text,1,i1-1);
        text:=copy(text,i1,length(text)-i1+1);

    until length(s)=0;
    result:=s;

end;

function SecDelivery(Headers:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1,s2:string;
    sd:integer;

begin
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Received:');
    s2:=GetLastHeader(headers,'Received:');
    extracttime(s1,d1);
    extracttime(s2,d2);

    sd:=abs(secondsbetween(d2,d1));
    s:='';
    s:=inttostr(sd mod 60)+' ';
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+'  '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+'  '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+'  '+s;


    result:=s;//'['+datetimetostr(d1)+']'#13#10'['+datetimetostr(d2)+']'#13#10+inttostr();

    n.Free;
end;
function reverse(s:string):string;
var n:tstrings;
    rs:string;
    i,j:integer;
begin
    rs:='';
    n:=tstringlist.Create;
    n.Text:=s;
    for i:=n.Count-1 downto 0 do begin
        for j:=length(n.Strings[i]) downto 1 do
            rs:=rs+n.Strings[i][j];
        rs:=rs+#13#10;
        end;


    result:=rs;
    n.free;
end;
function RemoveLines(s,repl:string;lines:integer):string;
var n:tstrings;
    rs:string;
    i:integer;
begin
    rs:=s;
    n:=tstringlist.Create;
    n.Text:=s;
    if n.Count>lines then begin
    rs:='';
    for i:=0 to lines div 2-1 do
        rs:=rs+n.Strings[i]+#13#10;
    if repl<>'' then rs:=rs+repl+#13#10;
    for i:=n.count-(lines-(lines div 2)) to n.count-1 do
        rs:=rs+n.Strings[i]+#13#10;
    end;
    result:=rs;
    n.free;

end;
function GetStartUpInfo:string;
begin
    result:=' ';
    case GetSystemMetrics(SM_CLEANBOOT) of
        0:result:=' ';
        1:result:='   ';
        2:result:='      ';
    end;

end;

function GetKBD:string;
var h:pchar;
begin
    GetMem(h,15000);
    GetKeyboardLayoutName(h);
    result:=StrPas(h);
    freemem(h);
end;
function DoFill(S,cuts:string;F:char;lin,lout:string;width,begstr,endstr,justify:integer):string;
var n:tstrings;
    i:integer;
//    j:integer;
    tts,ts:string;
begin
    ts:='';
    for i:=1 to width do ts:=ts+f;
    tts:=ts;
    ts:=ts+#13#10;
    n:=tstringlist.Create;
    if cuts<>'' then begin
    i:=pos(cuts,s);
    if i>0 then
    n.Text:=copy(s,1,i-1);
    end
    else n.Text:=s;


    for i:=0 to n.Count-1 do
        if (n.strings[i]<>'') then begin
        n.Strings[i]:=lin+n.Strings[i]+lout;
        with n do
        while length(strings[i])<width do
            case justify of
                1:strings[i]:=strings[i]+f;
                2:strings[i]:=f+strings[i];
            else
                if (length(strings[i]) mod 2)=0 then
                    strings[i]:=strings[i]+f
                else
                    strings[i]:=f+strings[i];
            end;

        end
        else n.Strings[i]:=ts;

    for i:=0 to n.Count-1 do
        if length(n.Strings[i])>width then
            if (n.strings[i][length(n.Strings[i])-1]=#$d)
            and (n.strings[i][length(n.Strings[i])]=#$a)
            then n.Strings[i]:=copy(n.Strings[i],1,width);

    for i:=1 to begstr do n.text:=ts+n.text;
    if endstr>0 then
        for i:=1 to endstr do
            if i<>endstr then
            n.text:=n.text+ts
            else
            n.text:=n.text+tts;


    result:=n.Text;
    n.Free;
end;

function GetMouseInfo:string;
var t:integer;
    s:string;
begin
    t:=GetSystemMetrics(SM_CMOUSEBUTTONS);

    if t=0 then s:=' ' else begin
        s:=inttostr(t)+'- ';
        if mouse.WheelPresent then s:=s+'  ';
    end;
    result:=s;
end;

function RandomCase(s:string):string;
var i:integer;
    c:string;
begin
    for i:=1 to length(s) do begin
        c:=s[i];
        if random(2)=1 then c:=AnsiUpperCase(c)
        else c:=AnsiLowerCase(c);
        s[i]:=c[1];

        end;
    result:=s;

end;

function GetMacroCount:string;
var i,k:integer;
begin
    k:=1;
    for i:=1 to length(macrolist) do
        if macrolist[i]=#13 then inc(k);
    result:=inttostr(k);
end;
function GetVer:string;
begin
    result:=ver_+'.'+GetMacroCount+'.'+ver_build;
end;


function GetMousePos:string;
begin

    result:=format('(%d,%d)',[mouse.cursorpos.x,mouse.cursorpos.y]);
end;

function GetDefaultPrinter: string;
var
  ResStr: array[0..255] of Char;
begin
  GetProfileString('Windows', 'device', '', ResStr, 255);
  Result := StrPas(ResStr);
end;


function GetBattStat:string;
var h:_system_power_status;
    s:string;
begin
    s:='  ';
    GetSystemPowerStatus(h);
    case h.ACLineStatus of
        1:s:='  ';
        0:begin
            case h.BatteryFlag of
                255:s:='  ';
                128:s:='   ,  ';
            end;
            if h.BatteryLifePercent<>255 then s:=s+', '+inttostr(h.BatteryLifePercent)+'% '
            else
            case h.BatteryFlag of
                1:s:=s+',  ';
                2:s:=s+',  ';
                4:s:=s+',   ';
            end;
            if h.BatteryLifeTime<>$FFFFFFFF then s:=s+format(', %.1f  ',[h.BatteryLifeTime/60]);
        end;


    end;
    if h.BatteryFlag=8 then s:=s+',  ';
    result:=s;
end;


procedure TBP_Initialize; stdcall;
begin

end;

procedure TBP_Finalize; stdcall;
begin

end;

function GetStr(const S: String; B: PChar; BSize: Integer): Integer;
begin
  if (B = nil) or (BSize < 0) then Result := Length(S) else
  try
    if BSize > Length(S) then BSize := Length(S);
    if BSize > 0 then Move(S[1], B[0], BSize);
    Result := BSize;
  except
    Result := 0;
  end;
end;

function TBP_GetName(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr('Useless Macro Collection', B, BSize);
end;

function TBP_GetVersion(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr(GetVer, B, BSize);
end;

function GetIV:string;
var i1,i2,i:integer;

begin
    i1:=pos('',umcinfostr);
    i2:=i1;
    for i:=i1 to length(umcinfostr) do
        if umcinfostr[i]='<' then begin
            i2:=i;
            break;
        end;
    result:=copy(umcinfostr,1,i1+5)+' '+GetVer+' '+copy(umcinfostr,i2,length(umcinfostr)-i2);
end;


function TBP_GetInfo(B: PChar; BSize: Integer): Integer; stdcall;
begin
  Result := GetStr(GetIV, B, BSize);
end;


function TBP_GetStatus: Integer; stdcall;
begin
  Result := 0;
end;

function TBP_NeedConfig: Integer; stdcall;
begin
  Result := 1;
end;

function TBP_NeedCOM: Integer; stdcall;
begin
  Result := 0;
end;

function TBP_Setup: Integer; stdcall;
begin
  MessageBoxEx(GetActiveWindow,
pchar('Useless macro collection '+GetVer+
  #13#10'  '#13#10'(c) 2003-2004  '+
  #13#10' :'+getmacrocount+
  #13#10'http://mini---soft.narod.ru')
  , 'UMC', MB_OK or MB_ICONINFORMATION, LANG_NEUTRAL);
  Result := 0;
end;

const
  midxSubject        = 1;
  midxDate           = 2;
  midxComment        = 3;
  midxInReplyTo      = 4;
  midxMessageID      = 5;
  midxNewsgroups     = 6;
  midxMailer         = 7;
  midxContentType    = 8;
  midxContentSubType = 9;
  midxExpireDate     = 10;
  midxOrganization   = 11;
  midxContentID      = 12;
  midxContentMD5     = 13;
  midxPriority       = 14;
  midxImportance     = 15;
  midxContentLocation= 16;
  midxEncoding       = 17;
  midxCharset        = 18;
  midxBoundary       = 19;
  midxMsgEncoding    = 20;
  midxC_Name         = 21;
  midxCD_Name        = 22;
  midxReportType     = 23;
  midxReferences     = 24;
  midxC_Description  = 25;
  midxContentDisposition = 26;
  midxContentLanguage = 27;
  midxC_ID            = 29;
  midxC_AccessType    = 30;
  midxC_Expiration    = 31;
  midxC_Size          = 32;
  midxC_Permission    = 33;
  midxC_Site          = 34;
  midxC_Directory     = 35;
  midxC_Mode          = 36;
  midxC_Server        = 37;
  midxC_Subject       = 38;
  midx_Files          = 39;
  midx_Msgs           = 40;
  midxReturnPath      = 41;
  midxFromName        = 42;
  midxFromAddr        = 43;
  midxReplyName       = 44;
  midxReplyAddr       = 45;
  midxToName          = 46;
  midxToAddr          = 47;
  midxServerID        = 48;
  midxRRC             = 49;
  midxRRQ             = 50;
  midxFileSubst       = 51;
  midxC_Number        = 52;
  midxC_Total         = 53;
  midxXCFile          = 54;
  midxMDN_To          = 55;
  midxMDN_Options     = 56;
  midxRefList         = 57;
  midxC_MICAlg        = 58;
  midxC_SMIMEType     = 59;
  midxC_Protocol      = 60;
  midxC_ProtocolType  = 61;
  midxC_ProtocolSubType=62;
  midxMatter          = 63;
  midxListHelp        = 64;
  midxListUnsub       = 65;
  midxListSub         = 66;
  midxListPost        = 67;
  midxListOwner       = 68;
  midxListArchive     = 69;
  midxDecodedFrom     = 70;
  midxDecodedTo       = 71;
  midxDecodedSubj     = 72;
  midxDecodedToEtc    = 73;

  mpidMessageHeader            =  100000;   // raw message RFC 822 header
  mpidMessageBody              =  100001;   // decoded message body (not available yet)
  mpidMessageAttachments       =  100002;   // a CR-delimited list of attachments
  mpidMessageSender            =  100003;   // decoded message sender (FROM)
  mpidMessageSubject           =  100004;   // decoded message subject
  mpidRawMessage               =  100005;   // raw message body


type
  TBPGetDataProc = function(ID, DataID: Integer; Buf: PChar; BufSize: Integer): Integer; stdcall;

function GetDataStr(Idx, MsgID: Integer; GetData: TBPGetDataProc): String;
var
  I: Integer;
  P: PChar;
  Sz: Integer;
begin
  P := nil;
  Sz := 0;
  Result := '';
  try
    I := GetData(MsgID, Idx, nil, 0);
    if I > 0 then
    begin
      if I > Sz then
      begin
        ReallocMem(P, I);
        Sz := I;
      end;
      I := GetData(MsgID, Idx, P, Sz);
      if I > 0 then SetString(Result, P, I);
    end;
  except
    Result := '';
  end;
  FreeMem(P);
end;

function TBP_GetSpamScore(MsgID: Integer; GetData: TBPGetDataProc): Integer; stdcall;
begin
  Result := -1;
end;

function TBP_FeedSpam(MsgID, IsSPAM: Integer; GetData: TBPGetDataProc): Integer; stdcall;
begin
  Result := 0;
end;

function TBP_GetMacroList(AData: Pointer; ADataSize: Integer): Integer; stdcall;
begin
  Result := GetStr(MacroList, AData, ADataSize);
end;

// Here is the current list of template object indexes
// Their meaning should be clear from the name :-)

const
  tpxQuotePrefix       = 200;
  tpxWrapJustify       = 201;
  tpxClear             = 202;
  tpxIsSignature       = 203;
  tpxSignComplete      = 204;
  tpxEncryptComplete   = 205;
  tpxUseSMIME          = 206;
  tpxUsePGP            = 207;
  tpxRCR               = 208;
  tpxRRQ               = 209;
  tpxSplit             = 210;
  tpxCharset           = 211;
  tpxPriority          = 212;
  tpxAttachVCard       = 213;
  tpxAccount           = 214;
  tpxFrom              = 215;
  tpxReplyTo           = 216;
  tpxReturnPath        = 217;
  tpxTo                = 218;
  tpxCC                = 219;
  tpxBCC               = 220;
  tpxOrg               = 221;
  tpxSubject           = 222;
  tpxFullSubject       = 223;
  tpxComment           = 224;
  tpxOldTo             = 225;
  tpxOldFrom           = 226;
  tpxOldReplyTo        = 227;
  tpxOldCC             = 228;
  tpxOldBCC            = 229;
  tpxOldSubject        = 230;
  tpxOldComment        = 231;
  tpxMatter            = 232;
  tpxOldMatter         = 233;
  tpxMsgID             = 234;
  tpxOldMsgID          = 235;
  tpxOldDate           = 236;
  tpxOldRcvDate        = 237;
  tpxOldReturn         = 238;
  tpxOldOrg            = 239;
  tpxOldText           = 240;
  tpxText              = 241;
  tpxSingleRe          = 242;
  tpxHeaders           = 243;
  tpxAttachments       = 244;
  tpxOldAttachments    = 245;
  tpxCookieCount       = 246;
  tpxOldCharset        = 247;
  tpxTotalPages        = 248;
  tpxCurrentPage       = 249;
  tpxTracking          = 248;
  tpxQuoteStyle        = 249;
  tpxTextLF            = 250;
  tpxRegExpPattern     = 251;
  tpxRegExpText        = 252;

function translit(a:string):string;
var i,j:integer;
    s:string;
    f:boolean;
const tranr=''+'';
      trane='yukengzfyvaproldesmit''b'''+'YUKENGZFYVAPROLDESMIT''B''';
begin
    translit:='unfinished!';

    s:='';
    for i:=1 to length(a) do
        case a[i] of
            '':s:=s+'sh';
            '':s:=s+'sch';
            '':s:=s+'zh';
            '':s:=s+'ya';
            '':s:=s+'ch';
            '':s:=s+'yu';
            '':s:=s+'yo';
            '':s:=s+'kh';
            '':s:=s+'ts';

            '':s:=s+'Sh';
            '':s:=s+'Sch';
            '':s:=s+'Zh';
            '':s:=s+'Ya';
            '':s:=s+'Ch';
            '':s:=s+'Yu';
            '':s:=s+'Yo';
            '':s:=s+'Kh';
            '':s:=s+'Ts';

        else
            f:=true;
            for j:=1 to length(tranr) do
                if a[i]=tranr[j] then begin
                    if not((trane[j] in ['Y','y']) and (s[length(s)] in ['Y','y'])) then
                    s:=s+trane[j];
                    f:=false;
                    break;
                end;
            if f then s:=s+a[i];
        end;
    translit:=s;
end;

function translit2(a:string):string;
var i,j:integer;
    s:string;
    f:boolean;
const tranr='';
      trane='jykeeHGww3xbfBapog*e4cmutb6JYKEHGWW3XbFBAPODE4CMUTb6EnnUu';
begin
//    translit:='unfinished!';

    s:='';
    for i:=1 to length(a) do
        case a[i] of
            '':s:=s+'>|<';
            '','':s:=s+'/|';
            '','':s:=s+'b|';
            '','':s:=s+'R';
            '','':s:=s+'|O';

        else
            f:=true;
            for j:=1 to length(tranr) do
                if a[i]=tranr[j] then begin
                    s:=s+trane[j];
                    f:=false;
                    break;
                end;
            if f then s:=s+a[i];
        end;
    translit2:=s;
end;


function replacech(c:char;str,a:string):string;
var i:integer;
    s:string;
begin
    s:='';
    for i:=1 to length(a) do
        if a[i]<>c then s:=s+a[i] else s:=s+str;
    replacech:=s;
end;
function replaceich(a:string):string;
var i:integer;
    s:string;
begin
    s:='';
    for i:=1 to length(a) do
        if not(a[i] in ['0'..'9','A'..'Z','a'..'z']) then s:=s+format('%%%.2x',[byte(a[i])]) else s:=s+a[i];
    replaceich:=s;
end;

function repl(a:char):char;
const vowell='';
      vowelu='ި';
      consl='';
      consu='';
var i:integer;
begin
    repl:=a;
    for i:=1 to length(vowell) do
        if a=vowell[i] then begin
            repl:=vowell[random(length(vowell))+1];
            exit;
        end;

    for i:=1 to length(vowelu) do
        if a=vowelu[i] then begin
            repl:=vowelu[random(length(vowelu))+1];
            exit;
        end;

    for i:=1 to length(consl) do
        if a=consl[i] then begin
            repl:=consl[random(length(consl))+1];
            exit;
        end;

    for i:=1 to length(consu) do
        if a=consu[i] then begin
            repl:=consu[random(length(consu))+1];
            exit;
        end;

end;

function GetIP:string;
const BufSize=255;
var
  Buf: pointer;
  Host : PHostEnt;
begin
    buf:=nil;
  try
    GetMem(Buf,BufSize);
    Winsock.GetHostName(Buf, BufSize);
    Host:=Winsock.GetHostByName(buf);
    if Host=NIL then result:= '127.0.0.1'//WinSock.htonl($07000001)  (*127.0.0.1 *)
    else result:= inet_ntoa(TInAddr(pointer(Host^.h_addr_list^)^));
    //   String.
  finally
    FreeMem(Buf,BufSize);
  end;
end;

function GetMemoryLoad:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=inttostr(lpms.dwMemoryLoad)+'%';
end;

function GetTotalPhys:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwTotalPhys/1048576]);
end;

function GetAvailPhys:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwAvailPhys/1048576]);
end;

function GetTotalPageFile:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwTotalPageFile/1048576]);
end;

function GetAvailPageFile:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwAvailPageFile/1048576]);
end;

function GetTotalVirtual:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwTotalVirtual/1048576]);
end;


function GetAvailVirtual:string;
var lpMS : TMemoryStatus;
begin
  lpMS.dwLength := SizeOf(lpMS);
  GlobalMemoryStatus(lpMS);
  result:=format('%4.2fM',[lpms.dwAvailVirtual/1048576]);
end;

function GetTPath:string;
var h:pchar;
begin
    getmem(h,10000);
    GetTempPath(10000,h);
    result:=strpas(h);
    freemem(h);
end;

function GetSPath:string;
var h:pchar;
begin
    getmem(h,10000);
    GetSystemDirectory(h,10000);
    result:=strpas(h);
    freemem(h);
end;
function MinutesLeft(hours,mins,houre,mine:integer):string;
var st:_SYSTEMTIME;
    rsec:integer;
begin
      getlocaltime(st);
      if (st.wDayOfWeek=0)or(st.wDayOfWeek=6)then result:=' !' else begin
      if (st.wHour*60+st.wMinute)>(houre*60+mine) then begin
        result:='  !!!';
        exit;
      end;
      if (st.wHour*60+st.wMinute)<(hours*60+mins) then begin
        result:='    ';
        exit;
      end;
      rsec:=(houre*60+mine)*60-((st.wHour*60+st.wMinute)*60+st.wSecond);
      if rsec<0 then rsec:=rsec+24*60*60;
      result:=format('     %d:%.2d:%.2d',[rsec div 3600,(rsec div 60)mod 60,rsec mod 60]);
      end;

end;
function dds(i:integer):string;
begin
    if (i mod 100) in [11..20] then result:=inttostr(i)+' '
    else
    case (i mod 10) of
        1:result:=inttostr(i)+' ';
        2,3,4:result:=inttostr(i)+' ';
    else
        result:=inttostr(i)+' ';
    end;

end;
function hds(i:integer):string;
begin
    if (i mod 100) in [11..20] then result:=inttostr(i)+' '
    else
    case (i mod 10) of
        1:result:=inttostr(i)+' ';
        2,3,4:result:=inttostr(i)+' ';
    else
        result:=inttostr(i)+' ';
    end;

end;

function DaysFrom(d,m,y:integer):string;
var
    days:integer;
begin

    try
    days:=DaysBetween(now,encodedatetime(y,m,d,0,0,0,0));
    result:=dds(days);
    except
    result:=format('   %.2d.%.2d.%.4d',[d,m,y]);
    end;
end;

function HoursFrom(d,m,y,h:integer):string;
var
    hrs:int64;
begin

    try
    hrs:=HoursBetween(now,encodedatetime(y,m,d,h,0,0,0));
    result:=hds(hrs);
    except
    result:=format('   %.2d.%.2d.%.4d %d',[d,m,y,h]);
    end;
end;

function MinsFrom(d,m,y,h,mins:integer):string;
var
    hrs:int64;
begin

    try
    hrs:=HoursBetween(now,encodedatetime(y,m,d,h,mins,0,0));
    result:=hds(hrs);
    except
    result:=format('   %.2d.%.2d.%.4d %d:%d',[d,m,y,h,mins]);
    end;
end;

function DaysLeft(Zarplata,Zarplatah,Avans,Avansh:integer):string;
var st:_SYSTEMTIME;
    zh,ah,curh:integer;
    s:string;
const dapm:array[1..13]of integer=(31,28,31,30,31,30,31,31,30,31,30,31,31);

begin
      s:='';
      getlocaltime(st);
      curh:=st.wDay*24+st.wHour;
      zh:=Zarplata*24+Zarplatah;
      ah:=Avans*24+Avansh;
      if avans=0 then ah:=10000000;
      if zh<curh then zh:=zh+dapm[st.wMonth]*24;
      if ah<curh then ah:=ah+dapm[st.wMonth]*24;
      zh:=zh-curh;
      ah:=ah-curh;
      if zh<ah then begin
        s:='   '+dds(zh div 24);
        if zarplatah in [1..23] then s:=s+'  '+hds(zh mod 24);
        if zarplata=st.wDay then s:=' ';
      end else begin
        s:='   '+dds(ah div 24);
        if avansh in [1..23] then s:=s+'  '+hds(ah mod 24);
        if avans=st.wDay then s:=' ';
      end;
      result:=s;
end;


function GetLogDrvStr:string;
var h:pchar;
    i,k:integer;

begin
    k:=10000;
    getmem(h,k);
    GetLogicalDriveStrings(k,h);
    for i:=0 to k-2 do
        if byte(h[i])=0 then begin
            h[i]:=' ';
            if byte(h[i+1])=0 then break;
        end;

    result:=strpas(h);
    freemem(h);
end;


function GetCompName:string;
var Size         : cardinal;
    PRes         : PChar;
    BRes         : boolean;
begin
    result:='  ';
  //  
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  PRes := StrAlloc(Size);
  BRes := GetComputerName(PRes, Size);

  if BRes then result:=StrPas(PRes);
end;

function GetUsName:string;
var Size         : cardinal;
    PRes         : PChar;
    BRes         : boolean;
begin
   result:='  ';
  //  
  Size := MAX_COMPUTERNAME_LENGTH + 1;
  PRes := StrAlloc(Size);
  BRes := GetUserName(PRes, Size);
  if BRes then result:=StrPas(PRes);
end;



function GetCPUSpeed:real;
const DelayTime=500;
var TimerHi, TimerLo: DWORD;
PriorityClass, Priority: Integer;
begin
 PriorityClass:=GetPriorityClass(GetCurrentProcess);
 Priority:=GetThreadPriority(GetCurrentThread);
 SetPriorityCLass(GetCurrentProcess,REALTIME_PRIORITY_CLASS);
 SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);
 Sleep(10);
 asm
    DW 310Fh           ;//This command of ASM RDTSC -   .
    MOV TimerLo, EAX
    MOV TimerHi, EDX
 end;
 Sleep(DelayTime);
 asm
    DW 310Fh
    SUB EAX, TimerLo
    SBB EDX, TimerHi
    MOV TimerLo, EAX
    MOV TimerHi, EDX
 end;
 SetThreadPriority(GetCurrentThread, Priority);
 SetPriorityClass(GetCurrentProcess,PriorityClass);
 Result:=TimerLo/(1000.0*DelayTime);
end;

{function GetCPU:string;
var t:TCPUIDInfo;
begin
    if not ExistCPUID then result:='  ' else begin
    CPUIDInfo(t);
    result:=t.CPUName;
    end;

end;}

function GetCPUf:string;
var t:TCPUInfo;
    s:string;
begin
    GetCPUInfo(t);
    s:=t.CpuName;

    s:=t.CPUName+format(' (Stepping %d, Model %d, Family %d',[t.Stepping,t.Model,t.Family]);

    if t.MMX then s:=s+', MMX';
    case t.CpuType of
        CPU_TYPE_INTEL:begin
            if (t.Features and APIC_FLAG)<>0 then s:=s+', APIC';
            if (t.Features and PSE36_FLAG)<>0 then s:=s+', 36-bit addr';
        end;

        CPU_TYPE_AMD:begin
            if t.HasExtendedInfo then
            if (t.Features and EAMD_3DNOW_FLAG)<>0 then s:=s+', 3Dnow!';

        end;
        CPU_TYPE_CYRIX:begin
            if (t.Features and ECYRIX_EMMX_FLAG)<>0 then s:=s+', EMMX';

        end;
    end;

//    if t.AMD3DNow then s:=s+', 3dnow!';
//    if t.APIC then
    s:=s+')';
//    end;
    result:=s;

end;
function GetFilesCount(Directory,mask:string):integer;
var n:tsearchrec;
    t:integer;
begin
    if mask='' then mask:='*.*';
    t:=0;
    if FindFirst(PathAddSeparator(directory)+mask,faAnyFile,n)=0 then begin
        t:=1;
        repeat
            inc(t);
        until FindNext(n)<>0;
    end;
    result:=t;
end;
function GetFilesSize(Directory,mask:string):int64;
var n:tsearchrec;
    t:int64;
begin
    if mask='' then mask:='*.*';
    t:=0;
    if FindFirst(PathAddSeparator(directory)+mask,faAnyFile,n)=0 then begin
        repeat
            t:=t+n.Size;
        until FindNext(n)<>0;
    end;
    result:=t;
end;

function GetProcList:string;
var n:tstrings;
begin
    n:=tstringlist.Create;
    if RunningProcessesList(n,true) then result:=n.Text else result:='   ';
end;

function GetTaskList:string;
var n:tstrings;
begin
    n:=tstringlist.Create;
    if GetTasksList(n) then result:=n.Text else result:='   ';
end;

{function GetCPUef:string;
var t:TCPUIDInfo;
    s:string;
begin
    s:='';
    if not ExistCPUID then s:='  ' else begin
    CPUIDInfo(t);
    s:=t.CPUName+format(' "%s" (Stepping %d, Model %d, Family %d',[t.IDstring,t.Stepping,t.Model,t.Family]);

    if t.MMX then s:=s+', MMX';
    if t.AMD3DNow then s:=s+', 3dnow!';
    if t.VirtualModeExtensions then s:=s+', Virtual Mode Extensions';
    if t.DebuggingExtensions then s:=s+', Debugging Extensions';
    if t.PageSizeExtensions then s:=s+', PageSize Extensions';
    if t.TimeStampCounter then s:=s+', Time Stamp Counter';
    if t.APIC then s:=s+', APIC';
    s:=s+')';
    end;
    result:=s;

end;}
function GetCPU_:string;
var n:TCPUinfo;
    s:string;
begin
    GetCPUInfo(n);
    s:=n.CpuName;

    result:=s;
end;
function GetCPU_v:string;
var n:TCPUinfo;
    s:string;
begin
    GetCPUInfo(n);
    s:=n.Manufacturer;

    result:=s;
end;

function TBP_ExecMacro(AMacro: Pointer; MaxLen: Integer; Template, Params: ITBPDataProvider): Integer; stdcall;

var
  S, P, str,str2: String;
  h:char;
  tval,t,t2,t3:integer;

 i,l: Integer;
  B,lin,lout,cuts: PChar;
  st:SystemTime;
  ms,sec,min,hour:DWORD;
//  Sz, BSz: Integer;
begin
  Result := -2;
  B := nil;
//  BSz := 0;
  if (MaxLen > 0) then
  try
    SetString(S, PChar(AMacro), MaxLen);
    if UpperCase(S) = 'UMC' then
    begin
      P := 'Useless Macro Collection '+GetVer+#13#10+MacroList;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCVER' then
    begin
      P := 'Useless Macro Collection '+GetVer;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCCUTHERE' then
    begin
      P := #13#10'-- '#13#10;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCGETHEADER' then
    begin

      t:=template.GetDataByID(tpxHeaders,nil,-1);
      getmem(b,t);
      template.GetDataByID(tpxHeaders,b,t);
      p:=copy(b,1,t);

      freemem(b);
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      str:=copy(b,1,t);

      p:=GetFirstHeader(p,str);
      p:=trim(copy(p,pos(str,p)+1+length(str),length(p)-pos(str,p)-1-length(str)));

      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCDELIVERYTIME' then
    begin

      t:=template.GetDataByID(tpxHeaders,nil,-1);
      getmem(b,t);
      template.GetDataByID(tpxHeaders,b,t);
      p:=copy(b,1,t);

      p:=SecDelivery(p);

      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCSTARTUPINFO' then
    begin
      P := GetStartUpInfo;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;


    if UpperCase(S) = 'UMCMOUSEINFO' then
    begin
      P := GetMouseInfo;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCMOUSEPOS' then
    begin
      P := GetMousePos;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCKBD' then
    begin
      P := GetKbd;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCPRN' then
    begin
      P := GetDefaultPrinter;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCDRVLIST' then
    begin
      P := GetLogDrvStr;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCPROCLIST' then
    begin
      P := GetProcList;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCTASKLIST' then
    begin
      P := GetProcList;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCSCREENRES' then
    begin

      P := format('%dx%d',[abs(screen.DesktopRect.Right-screen.DesktopRect.left),abs(screen.DesktopRect.Bottom-screen.DesktopRect.Top)]);
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCCPUSPEED' then
    begin
      P := format('%d',[round(GetCPUSpeed)]);
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCCOMPNAME' then
    begin
      P := GetCompName;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCWINVER' then
    begin
      P := GetWindowsVersionString+' '+NtProductTypeString+' '+GetWindowsServicePackVersionString;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCBATT' then
    begin
      P := GetBattStat;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCUSERNAME' then
    begin
      P := GetUsName;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMLOAD' then
    begin
      P := GetMemoryLoad;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMTPHYS' then
    begin
      P := GetTotalPhys;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCMEMTPHYS' then
    begin
      P := GetTotalPhys;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMAPHYS' then
    begin
      P := GetAvailPhys;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMTPAGE' then
    begin
      P := GetTotalPageFile;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMAPAGE' then
    begin
      P := GetAvailPageFile;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMTVIRT' then
    begin
      P := GetTotalVirtual;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMEMAVIRT' then
    begin
      P := GetAvailVirtual;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;


    if UpperCase(S) = 'UMCCPUTICKS' then
    begin

      P := format('%.2f ',[GetTickCount/1000*GetCPUSpeed/1000]);

      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;


    if UpperCase(S) = 'UMCTICKCOUNT' then
    begin
      ms:=GetTickCount;
      sec:=(ms div 1000)mod 60;
      min:=(ms div 60000)mod 60;
      hour:=ms div 3600000;
//      day:=(ms div 86400000);
      ms:=ms mod 1000;
      P := format('%d:%.2d:%.2d,%.4d',[hour,min,sec,ms]);
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCCPUNAME' then
    begin
      P := GetCPU_;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCCPUVENDOR' then
    begin
      P := GetCPU_v;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCCPUNAMEL' then
    begin
      P := GetCPUf;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

{    if UpperCase(S) = 'UMCCPUFEATURES' then
    begin
      P := GetCPUef;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;}

    if UpperCase(S) = 'UMCIP' then
    begin
      P := GetIP;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCTEMPPATH' then
    begin
      P := GetTPath;//format('%5.2f',[GetCPUSpeed]);
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCTIME' then
    begin
      getlocaltime(st);
      P := datetimetostr(now)+'.'+inttostr(st.wMilliseconds);
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCDAYSFROM' then
    begin
      P := daysfrom(params.GetIntValue(0),params.GetIntValue(1),params.GetIntValue(2));
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCHOURSFROM' then
    begin
      P := hoursfrom(params.GetIntValue(0),params.GetIntValue(1),params.GetIntValue(2),params.GetIntValue(3));
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCMINSFROM' then
    begin
      P := minsfrom(params.GetIntValue(0),params.GetIntValue(1),params.GetIntValue(2),params.GetIntValue(3),params.GetIntValue(4));
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCDRVFREEK' then
    begin
      if params.ItemCount<1 then p:=' !'
      else begin
        params.GetDataByID(0,@h,1);
        p:=inttostr(round(diskfree(byte(upcase(h))-byte('A')+1)/1024))+'K';
      end;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCDRVFREEM' then
    begin
      if params.ItemCount<1 then p:=' !'
      else begin
        params.GetDataByID(0,@h,1);
        p:=inttostr(round(diskfree(byte(upcase(h))-byte('A')+1)/1024/1024))+'M';
      end;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCTIMELEFT' then begin
        p:=MinutesLeft(params.GetIntValue(0),params.GetIntValue(1),params.GetIntValue(2),params.GetIntValue(3));
        Result := 118999;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCDAYSLEFT' then begin
        p:=DaysLeft(params.GetIntValue(0),params.GetIntValue(1),params.GetIntValue(2),params.GetIntValue(3));
        Result := 118999;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCDRVFREE' then
    begin
      if params.ItemCount<1 then p:=' !'
      else begin
        params.GetDataByID(0,@h,1);
        p:=inttostr(diskfree(byte(upcase(h))-byte('A')+1));
      end;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCDRVFREEP' then
    begin
      if params.ItemCount<1 then p:=' !'
      else begin
        params.GetDataByID(0,@h,1);
        t:=diskfree(byte(upcase(h))-byte('A')+1);
        if t<>0 then
        p:=inttostr(round(diskfree(byte(upcase(h))-byte('A')+1)/t))+'%';
      end;
      Result := 118999;
      Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCVOLNAME' then begin
        result:=118999;
        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);
        p:=copy(b,1,t);

        freemem(b);
        t:=params.GetDataByID(1,nil,-1);
        getmem(b,t);
        params.GetDataByID(1,b,t);
        str:=copy(b,1,t);

        p:=GetVolumeName(p);
        if p='' then p:=str;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCVOLSNUM' then begin
        result:=118999;
        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);
        p:=copy(b,1,t);
        p:=GetVolumeSerialNumber(p);
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCVOLFS' then begin
        result:=118999;
        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);
        p:=copy(b,1,t);
        p:=GetVolumeFileSystem(p);
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCGETIP' then begin
        result:=118999;
        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);
        p:=copy(b,1,t);
        p:=GetIPAddress(p);
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCRCASE' then begin
        result:=118999;
        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);
        p:=copy(b,1,t);
        p:=RandomCase(p);
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;


    if UpperCase(S) = 'UMCBIOSNAME' then begin
        result:=118999;
        p:=GetBIOSName;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCBIOSCOPY' then begin
        result:=118999;
        p:=GetBIOSCopyRight;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCBIOSINFO' then begin
        result:=118999;
        p:=GetBIOSExtendedInfo;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;
    if UpperCase(S) = 'UMCBIOSDATE' then begin
        result:=118999;
        p:=datetostr(GetBIOSDate);
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;


    if UpperCase(S) = 'UMCIZVRAT' then
    begin
      Result :=118999;
      if params.ItemCount<2 then begin
      p:='   !';
      Template.SetDataByID(Result, pchar(p), length(p));
      end
      else begin
        tval:=params.GetIntValue(1);

        t:=params.GetDataByID(0,nil,-1);
        getmem(b,t);
        params.GetDataByID(0,b,t);

        for i:=1 to t-1 do
            if (random(100)<tval) then b[i]:=repl(b[i]);// else b2[i]:=b[i];

        Template.SetDataByID(Result, b, t);

      end;
    end;

    if UpperCase(S) = 'UMCFILL' then
    begin
      Result :=118999;

//      tval:=params.GetIntValue(1);

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t+1);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      t3:=params.GetDataByID(8,nil,-1);
      getmem(cuts,t3);
      params.GetDataByID(8,cuts,t3);

      params.GetDataByID(1,@h,1);

      t:=params.GetDataByID(3,nil,-1);
      getmem(lin,t+1);
      params.GetDataByID(3,lin,t);

      t2:=params.GetDataByID(4,nil,-1);
      getmem(lout,t2+1);
      params.GetDataByID(4,lout,t2);

      p:=DoFill(P,copy(cuts,1,t3),h,copy(lin,1,t),copy(lout,1,t2),params.GetIntValue(2),params.GetIntValue(5),params.GetIntValue(6),params.GetIntValue(7));

      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCSTRINGS' then
    begin
      Result :=118999;

      p:='';
      for i:=0 to params.ItemCount-1 do begin
      t:=params.GetDataByID(i,nil,-1);
      getmem(b,t);
      params.GetDataByID(i,b,t);
      if i=0 then
      p:=p+copy(b,1,t)
      else
      p:=p+#13#10+copy(b,1,t)

      end;

      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCFILESSIZEM' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      p:=format('%.2fM',[GetFilesSize(p,str)/1024/1024]);

      Template.SetDataByID(Result, pchar(p), length(p));
    end;
    if UpperCase(S) = 'UMCFILESSIZEK' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      p:=format('%.2fK',[GetFilesSize(p,str)/1024]);

      Template.SetDataByID(Result, pchar(p), length(p));
    end;
    if UpperCase(S) = 'UMCFILESSIZE' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      p:=inttostr(GetFilesSize(p,str));

      Template.SetDataByID(Result, pchar(p), length(p));
    end;
    if UpperCase(S) = 'UMCFILESCOUNT' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      p:=inttostr(GetFilesCount(p,str));

      Template.SetDataByID(Result, pchar(p), length(p));
    end;


    if UpperCase(S) = 'UMCREPLACE' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);
      freemem(b);

      t:=params.GetDataByID(2,nil,-1);
      getmem(b,t);
      params.GetDataByID(2,b,t);
      str2:=copy(b,1,t);

      if pos(str,str2)>0 then p:='!         !'#13#10+p

      else

      while pos(str,p)>0 do begin
        i:=pos(str,p);
        l:=length(str);
        p:=copy(p,1,i-1)+str2+copy(p,i+l,length(p)-i-l);
      end;


      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCCITE' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);
      if p='' then begin
        freemem(b);

        t:=template.GetDataByID(tpxText,nil,-1);
        getmem(b,t);
        template.GetDataByID(tpxText,b,t);
        p:=copy(b,1,t);
      end;


      freemem(b);

      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      p:=RemoveLines(p,str,params.GetIntValue(2));


      Template.SetDataByID(Result, pchar(p), length(p));
    end;



    if UpperCase(S) = 'UMCPS' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      freemem(b);
      t:=params.GetDataByID(1,nil,-1);
      getmem(b,t);
      params.GetDataByID(1,b,t);
      str:=copy(b,1,t);

      freemem(b);
      t:=params.GetDataByID(2,nil,-1);
      getmem(b,t);
      params.GetDataByID(2,b,t);
      str2:=copy(b,1,t);

      p:=AddFix(p,str,str2);


      Template.SetDataByID(Result, pchar(p), length(p));
    end;


    if UpperCase(S) = 'UMCKILLCITE' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      i:=params.GetIntValue(1);
      if i=0 then i:=2;

      p:=KillCite(p,i);


      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCGETLINKS' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      if p='' then begin
        freemem(b);

        t:=template.GetDataByID(tpxText,nil,-1);
        getmem(b,t);
        template.GetDataByID(tpxText,b,t);
        p:=copy(b,1,t);
      end;

      p:=GetLinks(p);


      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCREVERSE' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      p:=Reverse(p);




      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCSCREENDEPTH' then
    begin
      Result :=118999;
      p:=inttostr(getdevicecaps(GetDC(application.Handle),COLORRES));
      if p='24' then p:='32';
      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCSCREENRRATE' then
    begin
      Result :=118999;
      p:=inttostr(getdevicecaps(GetDC(application.Handle),VREFRESH));
      Template.SetDataByID(Result, pchar(p), length(p));
    end;


    if UpperCase(S) = 'UMCCUTON' then
    begin
      Result :=118999;

      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=copy(b,1,t);

      t2:=params.GetDataByID(1,nil,-1);
      getmem(lout,t2);
      params.GetDataByID(1,lout,t2);

      str:=copy(lout,1,t2);

      if str<>'' then begin
      t3:=pos(str,p);
      if t3>0 then
      p:=copy(p,1,t3-1);
      end;

      Template.SetDataByID(Result, pchar(p), length(p));
    end;
    if UpperCase(S) = 'UMCGFCOMMON' then begin
        p:=GetCommonFilesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCURRENT' then begin
        p:=GetCurrentFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFPROGRAMFILES' then begin
        p:=GetProgramFilesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFWIN' then begin
        p:=GetWindowsFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFSYS' then begin
        p:=GetWindowsSystemFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFTEMP' then begin
        p:=GetWindowsTempFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFDESKTOP' then begin
        p:=GetDesktopFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFPROGRAMS' then begin
        p:=GetProgramsFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFPERSONAL' then begin
        p:=GetPersonalFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFFAVORITES' then begin
        p:=GetFavoritesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFSTARTUP' then begin
        p:=GetStartupFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFRECENT' then begin
        p:=GetRecentFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFSENDTO' then begin
        p:=GetSendToFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFMENU' then begin
        p:=GetStartmenuFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFDESKTOPD' then begin
        p:=GetDesktopDirectoryFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFNETHOOD' then begin
        p:=GetNethoodFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFFONTS' then begin
        p:=GetFontsFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCMENU' then begin
        p:=GetCommonStartmenuFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCPROGRAMS' then begin
        p:=GetCommonProgramsFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCSTARTUP' then begin
        p:=GetCommonStartupFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCDESKTOP' then begin
        p:=GetCommonDesktopdirectoryFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCAPPDATA' then begin
        p:=GetCommonAppdataFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFAPPDATA' then begin
        p:=GetAppdataFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFPRINTHOOD' then begin
        p:=GetPrinthoodFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCFAVORITES' then begin
        p:=GetCommonFavoritesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFTEMPLATES' then begin
        p:=GetTemplatesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFICACHE' then begin
        p:=GetInternetCacheFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFCOOKIES' then begin
        p:=GetCookiesFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;
    if UpperCase(S) = 'UMCGFHISTORY' then begin
        p:=GetHistoryFolder;
        template.SetDataByID(118999,pchar(p),length(p));result:=118999;
    end;

    if UpperCase(S) = 'UMCMKLINK' then
    begin
      Result :=213218;
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      params.GetDataByID(1,@h,1);


      p:=copy(b,1,t);

      p:=replaceich(p);
      Template.SetDataByID(Result, pchar(p), length(p));
    end;
    if UpperCase(S) = 'UMC_CPU' then begin
        result:=118999;
        p:=GetCPU_;
        Template.SetDataByID(Result, PChar(P), Length(P));
    end;

    if UpperCase(S) = 'UMCXOR' then
    begin
      Result :=213218;
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      tval:=params.GetIntValue(1);

      p:=copy(b,1,t);

      for i:=1 to length(p) do begin
        p[i]:=char(byte(p[i])xor tval);
      end;
      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCREPLACECHAR' then
    begin
      Result :=213218;
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      params.GetDataByID(1,@h,1);


      p:=copy(b,1,t);

      freemem(b);
      t:=params.GetDataByID(2,nil,-1);
      getmem(b,t);
      params.GetDataByID(2,b,t);

      str:=copy(b,1,t);

      p:=replacech(h,str,p);
      Template.SetDataByID(Result, pchar(p), length(p));
    end;

    if UpperCase(S) = 'UMCTRANSLIT' then
    begin
      Result :=118999;
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=b;

      p:=translit(p);

      Template.SetDataByID(Result, pchar(p), length(p));

    end;

    if UpperCase(S) = 'UMCTRANSLIT2' then
    begin
      Result :=118999;
      t:=params.GetDataByID(0,nil,-1);
      getmem(b,t);
      params.GetDataByID(0,b,t);
      p:=b;

      p:=translit2(p);

      Template.SetDataByID(Result, pchar(p), length(p));

    end;


  finally
    FreeMem(B);
  end;
end;


exports TBP_NeedConfig{, TBP_FeedSpam}, TBP_GetStatus, TBP_GetVersion, TBP_GetName,
  TBP_Finalize, TBP_Initialize, TBP_Setup, TBP_NeedCOM, {TBP_GetSpamScore,}
  TBP_GetMacroList, TBP_ExecMacro, TBP_GetInfo;

begin
end.
