function cmpp(a,b:integer):integer;
begin
    if a=0 then result:=b else
    if b=0 then result:=a else
    if a<b then result:=a else result:=b;
end;
function synDeQuote(s:string):string;
begin
    if s='' then begin
        result:='';
        exit;
    end;
    if s[1]='"' then s:=copy(s,2,length(s)-1);
    if s[length(s)]='"' then s:=copy(s,1,length(s)-1);
    if s[1]='''' then s:=copy(s,2,length(s)-1);
    if s[length(s)]='''' then s:=copy(s,1,length(s)-1);
    result:=s;
end;
function extracttime(s:string;var Date:tdatetime):boolean;
var i:integer;
    n:tstringlist;

    dd,mm,yy:integer;
    h,m,sc,delta:integer;
    z,z2:tdatetime;


begin
    z2:=date;
    n:=tstringlist.Create;
    while pos(';',s)<>0 do begin
        i:=pos(';',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;
    while pos(',',s)<>0 do begin
        i:=pos(',',s);
        s:=copy(s,i+1,length(s)-i+1);
    end;

    extractstrings([' ',':','/'],[],pchar(s),n);
    dd:=strtoint(n.Strings[0]);
    n.Strings[1]:=lowercase(n.Strings[1]);
    mm:=0;
    case n.Strings[1][1] of
        'f':mm:=2;
        's':mm:=9;
        'o':mm:=10;
        'n':mm:=11;
        'd':mm:=12;
    else
        if n.Strings[1]='jan' then mm:=1;
        if n.Strings[1]='mar' then mm:=3;
        if n.Strings[1]='apr' then mm:=3;
        if n.Strings[1]='jun' then mm:=6;
        if n.Strings[1]='jul' then mm:=7;
        if n.Strings[1]='aug' then mm:=8;
    end;
    yy:=strtoint(n.Strings[2]);
    h:=strtoint(n.Strings[3]);
    m:=strtoint(n.Strings[4]);
    sc:=strtoint(n.Strings[5]);
    if (n.Strings[6]='GMT') or (n.Strings[6]='UMC') then
        delta:=0
    else
        delta:=-strtoint(n.Strings[6]) div 100;
    if yy<2000 then yy:=yy+2000;
    result:=tryencodedatetime(yy,mm,dd,h,m,sc,0,z);
    if result then begin
        z:=inchour(z,delta);
        date:=z;
    end else date:=z2;
    n.Free;
end;
function GetFirstHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,j:integer;
    eflag:boolean;
begin
    s:='';
    eflag:=false;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do begin
        if eflag then break;
        if pos(hname,n.Strings[i])=1 then begin
            s:=trim(n.Strings[i]);
            for j:=i+1 to n.Count-1 do
                if n.Strings[j][1]<=' ' then
                s:=s+trim(n.Strings[j]) else
                break;
            eflag:=true;
        end;
    end;

    result:=s;

    n.free;
end;
function GetLastHeader(headers,hname:string):string;
var s:string;
    n:tstringlist;
    i,ii,j:integer;
begin
    s:='';
    ii:=0;
    n:=tstringlist.Create;
    n.Text:=headers;
    for i:=0 to n.Count-1 do
        if pos(hname,n.Strings[i])<>0 then ii:=i;

    s:=trim(n.Strings[ii]);
    for j:=ii+1 to n.Count-1 do
       if n.Strings[j][1]=' ' then s:=s+trim(n.Strings[j]) else break;

    result:=s;

    n.free;
end;
function RemoveLines(s,repl:string;lines:integer):string;
var n:tstrings;
    rs:string;
    i:integer;
begin
    rs:=s;
    n:=tstringlist.Create;
    n.Text:=s;
    if n.Count>lines then begin
    rs:='';
    for i:=0 to lines div 2-1 do
        rs:=rs+n.Strings[i]+#13#10;
    if repl<>'' then rs:=rs+repl+#13#10;
    for i:=n.count-(lines-(lines div 2)) to n.count-1 do
        rs:=rs+n.Strings[i]+#13#10;
    end;
    result:=rs;
    n.free;

end;
function replaceich(a:string):string;
var i:integer;
    s:string;
begin
    s:='';
    for i:=1 to length(a) do
        if not(a[i] in ['0'..'9','A'..'Z','a'..'z']) then s:=s+format('%%%.2x',[byte(a[i])]) else s:=s+a[i];
    replaceich:=s;
end;
function KillCite(text:string;clevel:integer):string;
var ts,s:string;
    n:tstringlist;
    i:integer;
begin
    result:=text;
    n:=tstringlist.Create;
    n.Text:=text;
    s:='';
    ts:='';
    for i:=1 to clevel do ts:=ts+'>';
    if ts='' then exit;

    for i:=0 to n.Count-1 do
        if pos(ts,n.Strings[i])=0 then s:=s+n.Strings[i]+#13#10;

    result:=s;
    n.Free;

end;
function SecDelivery(Headers,s_sec,s_min,s_hour,s_day:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1,s2:string;
    sd:integer;

begin
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Received:');
    s2:=GetLastHeader(headers,'Received:');
    extracttime(s1,d1);
    extracttime(s2,d2);

    sd:=abs(secondsbetween(d2,d1));
    s:='';

    {$IFNDEF UMP}
    if s_sec='' then s_sec:=o[44];
    if s_min='' then s_min:=o[45];
    if s_hour='' then s_hour:=o[46];
    if s_day='' then s_day:=o[47];
    {$ENDIF}

    s:=inttostr(sd mod 60)+' '+s_sec;
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+' '+s_min+' '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+' '+s_hour+' '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+' '+s_day+' '+s;

    result:=s;

    n.Free;
end;
function SecReply(Headers,s_sec,s_min,s_hour,s_day:string):string;
var n:tstringlist;
    d1,d2:tdatetime;
    s,s1:string;
    sd:integer;
    m:_SYSTEMTIME;

begin
    getsystemtime(m);
    n:=tstringlist.Create;
    n.Text:=headers;
    s1:=GetFirstHeader(headers,'Date:');
    extracttime(s1,d1);
    d2:=EncodeDateTime(m.wYear,m.wMonth,m.wDay,m.wHour,m.wMinute,m.wSecond,m.wMilliseconds);

    sd:=abs(secondsbetween(d2,d1));
    s:='';
    {$IFNDEF UMP}
    if s_sec='' then s_sec:=o[44];
    if s_min='' then s_min:=o[45];
    if s_hour='' then s_hour:=o[46];
    if s_day='' then s_day:=o[47];
    {$ENDIF}

    s:=inttostr(sd mod 60)+' '+s_sec;
    if sd>=60 then s:=inttostr((sd div 60) mod 60)+' '+s_min+' '+s;
    if sd>=3600 then s:=inttostr((sd div 3600)mod 24)+' '+s_hour+' '+s;
    if sd>=86400 then s:=inttostr((sd div 86400))+' '+s_day+' '+s;

    result:=s;

    n.Free;
end;
function GetCharset(headers:string):string;
var s:string;
    b:integer;
begin
    s:=AnsiLowerCase(headers);
    s:=GetFirstHeader(s,'content-type');
    b:=pos('charset=',s);
    if b=0 then s:='';
    b:=b+8;
    s:=copy(s,b,length(s)-b+1);
    s:=synDeQuote(s);
    if s='' then s:='<unknown>';
    b:=pos(';',s);
    if b>0 then s:=copy(s,1,b-1);
    b:=pos(' ',s);
    if b>0 then s:=copy(s,1,b-1);
    result:=s;

end;
function GetMailer(headers,alt:string):string;
var s:string;
begin
    s:=GetFirstHeader(headers,'X-Mailer:');
    if s='' then s:=alt else s:=trim(copy(s,10,length(s)-9));
    result:=s;
end;
function GetLinks(Text:string):string;
var s:string;
    i,i1,i2:integer;
begin
    s:='';
    text:=text+'     ';
    for i:=1 to length(text) do if text[i]<' ' then text[i]:=' ';
    repeat
        i1:=pos('http:',LowerCase(text));
        i2:=pos('ftp:',LowerCase(text));
        i:=cmpp(i1,i2);
//        if i1<i2 then i:=i1 else i:=i2;
        if i=0 then break;
        text:=copy(text,i,length(text)-i+1);

        i1:=0;
        for i:=1 to length(text) do
            if not(lowercase(text)[i] in ['a'..'z','!'..'/','~','_','@',':','0'..'9']) then begin
                i1:=i;
                break;
            end;
        if i1=0 then i1:=length(text);

        if s<>'' then s:=s+#13#10;
        s:=s+copy(text,1,i1-1);
        text:=copy(text,i1,length(text)-i1+1);

    until length(s)=0;
    result:=s;

end;
