unit OMC_declarations;

interface

uses windows, sysutils;

{$i umc.inc}
const
    AVC_OK  = 0;
    AVC_Error = -3;
    AVC_NotSupported = -1;

    _omcslogfile='omc.log';

function GetStr(const S: String; B: PChar; BSize: Integer): Integer;
function GetOMCver:string;
procedure _(s:string='');overload;

var __omc__log:textfile;


implementation

function GetTPath:string;
var h:pchar;
begin
    getmem(h,10000);
    GetTempPath(10000,h);
    result:=h;
//    result:=strpas(h);
    if result[length(result)]<>'/' then result:=result+'/';
//    result:=PathAddSeparator(strpas(h));
    freemem(h);
end;


procedure __initlogger;
begin
//    if not uselogging then exit;
    assignfile(__omc__log,GetTPath+_omcslogfile);
    rewrite(__omc__log);
//    __init:=true;
//    __;
    writeln(__omc__log,'Started at '+datetimetostr(now));
    _;
    _;
    _('Log Started');
    _;
end;
procedure __closelogger;
//var //n:tstringlist;
//    i,k:integer;
begin
//    if not uselogging then exit;
    closefile(__omc__log);
//    closefile(__umc__slog);
{    try
    n:=tstringlist.Create;
    n.LoadFromFile(GetTPath+_umclogfile);
    if n.Count>_max then begin
        k:=n.Count-_max;
        for i:=0 to k do n.Strings[i]:='';
        n.Text:=trim(n.text);
        n.SaveToFile(_umclogfile);
    end;
    n.Free;
    except
    _('Failed to closelogger');
    end;}
end;


procedure _(s:string='');
var str:string;
begin
//    if (not UseLogging)or(not __init) then exit;
    if s='' then writeln(__omc__log,'')else begin
    str:=timetostr(now)+': '+{getmm+': '+}s;
    writeln(__omc__log,str);
    flush(__omc__log);
{    if (umcsetupf<>nil)and(uselogging) then begin
        try
            umcsetupf.DebugBox.Items.Add(str);
        except
        end;
    end;}
    end;
end;


function GetOMCver:string;
begin
    result:=oautover+'.'+oautobld;
end;

function GetStr(const S: String; B: PChar; BSize: Integer): Integer;
begin
  if (B=nil) or (BSize < 0) then Result := Length(S) else
  try
    if BSize > Length(S) then BSize := Length(S);
    if BSize > 0 then Move(S[1], B[0], BSize);
    Result := BSize;
  except
    Result := 0;
  end;
end;


initialization
    __initlogger;
finalization
    __closelogger;
end.
