unit UMC_SMS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  Tsmsform = class(TForm)
    Panel1: TPanel;
    SMScounter: TPanel;
    smsmem: TMemo;
    DoneButton: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure updcap;
    function getsms(len:integer=160):string;
    procedure smsmemKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DoneButtonClick(Sender: TObject);

  private
    maxl:integer;
  public
    hgt:boolean;
  end;

var
  smsform: Tsmsform=nil;
  __BUF:STRING='';
  tme:tdatetime;

function GetSMS(len:integer=160):string;

implementation

uses UMCaux, dateutils, UMClogger;

{$R *.dfm}

procedure Tsmsform.FormCreate(Sender: TObject);
begin
    caption:='Useless Macro Collection '+getumcver;
    maxl:=160;
    smsmem.Clear;
    updcap;
end;

procedure Tsmsform.updcap;
begin
    smscounter.Caption:='['+inttostr(length(smsmem.Text))+'/'+inttostr(maxl)+']';
end;

function Tsmsform.getsms;
begin
    maxl:=len;
    smsmem.Clear;
    smsmem.MaxLength:=maxl;
    smsform.ShowModal;
    updcap;
    hgt:=false;

    while smsform.Showing do begin
        updcap;
        application.ProcessMessages;
        if hgt then exit;

    end;
    result:=smsmem.Text;
end;

procedure Tsmsform.smsmemKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    updcap;
    if (shift=[ssCtrl]) and (key=VK_RETURN) then self.Close;
    if length(smsmem.Text)>maxl then key:=0;
end;

procedure Tsmsform.DoneButtonClick(Sender: TObject);
begin
    close;
end;

function GetSMS(len:integer=160):string;
begin
    _(inttostr(millisecondsbetween(now,tme)));
    if (millisecondsbetween(now,tme)<780) then begin
        if smsform<>nil then begin
//            _('Freeing smsform');
//            smsform.hgt:=true;
//            smsform.Close;
//            smsform.Free;
//            smsform:=tsmsform.Create(nil);
            smsform.Show;
            result:=smsform.getsms(len);
            smsform.Free;
            smsform:=nil;
            tme:=now;
            __buf:=result;
            _('Result is '+__buf);
            exit;
        end else begin
            _('Cache value returned');
            result:=__buf;
            tme:=now;
            exit;
        end;
    end;
    _('Request for SMS detected');
    tme:=now;
//    if smsform<>nil then smsform.Free;
    smsform:=tsmsform.Create(nil);
    result:=smsform.getsms(len);
    smsform.Free;
    smsform:=nil;
    __buf:=result;
    tme:=now;
end;

end.
