unit UMC_wordlist_tester;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, UMCwordlist, Grids, ValEdit, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    vle: TValueListEditor;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    z:tword;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    z.create('ABS');
    vle.Strings.LoadFromFile('1');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    vle.Strings.SaveToFile('1');
    z.destroy;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=VK_RETURN then begin
        z.AddWord(edit1.Text);
        edit1.Text:='';
        button1click(sender);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var u:pword;
begin
    u:=@z;
//    memo1.Lines.Clear;
{    repeat
        memo1.Lines.Add(u^.Value+' '+floattostr(u^.Freq));
        u:=u^.next;
//        if u^.next=u then u.next:=nil;
    until u=nil;}


end;

procedure TForm1.Button2Click(Sender: TObject);
var a:variant;
begin
//    a:=

end;
function vals(str:string):integer;
var i,m:integer;
begin
    result:=0;
    i:=pos('=',str);
    str:=copy(str,i+1,length(str)-i);
    val(str,m,i);
    if i<>0 then m:=0;
    result:=m;
end;

function presort(h:tstrings):string;
var i:integer;
    n1,n2:integer;
    s:string;
    n:tstrings;

begin
    n:=tstringlist.Create;
    n.Text:=h.Text;

    for i:=0 to n.Count-2 do begin
        n1:=vals(n.strings[i]);
        n2:=vals(n.strings[i+1]);
        if n2>n1 then begin
            s:=n.strings[i];
            n.strings[i]:=n.Strings[i+1];
            n.Strings[i+1]:=s;
        end;
    end;
    result:=n.Text;
    n.Free;
end;                    { TODO :  %UMCREPLACE      }
procedure TForm1.Edit1Change(Sender: TObject);
var n,m:integer;
//    v:tstringlist;
begin
    val(vle.Values[edit1.Text],n,m);
    if m<>0 then n:=0;
    vle.Values[edit1.Text]:=inttostr(n+1);
{    v:=tstringlist.Create;
    v.Text:=vle.Strings.Text;
    v.Sort;
    vle.Strings.Text:=v.Text;
    v.Free;}
    vle.Strings.Text:=presort(vle.Strings);
//    vle.Strings.StringsAdapter

end;

procedure TForm1.Timer1Timer(Sender: TObject);
//var n:tstream;
begin
    vle.Strings.Text:=presort(vle.Strings);
//    vle.Strings.SaveToStream(n);
{    n:=tstringstream.Create(vle.Strings.Text);
    vle.Strings.LoadFromStream(n);
    n.Free;}
end;

end.
