unit UMClanguages;

interface
uses inifiles, controls, stdctrls, forms, classes, registry, sysutils, comctrls, extctrls, menus;
const omax=200;
var o:array[1..omax]of string;
    strSec:string='';
    strMin:string='';
    strHour:string='';
    strDay:string='';
    strMounth:string='';

procedure WriteLanguageData(filename:string);
procedure ReadLanguageData(filename:string);
procedure RestoreStrings;
procedure ReadStrings(filename:string);
procedure StoreStrings(filename:string);
procedure ReadTrayMenu(filename:string);
procedure WriteTrayMenu(filename:string);

procedure GetStr;

implementation

uses UMCsetupform, UMCmiscdata, UMCaux, CoolTrayIcon, UMClogger;
procedure GetStr;
begin
    try
    if slangfile<>'' then ReadStrings(umcdir+slangfile);
    except
    _('Can''t read strings');
    end;
    try
    if slangfile<>'' then ReadLanguageData(umcdir+slangfile);
    except
    _('Can''t read langdata');
    end;
end;

procedure saveall(c:tcomponent;n:tinifile);
var i,j:integer;
    tc:tcomponent;
begin
//    _('Saving all the strings');
    for i:=0 to c.ComponentCount-1 do begin
        tc:=c.Components[i];
//        n.WriteString('Debug','Current',tc.ClassName);
        if tc is TLabel then
        n.WriteString('Labels',tc.Name,(tc as tlabel).Caption);
        if tc is TButton then
        n.WriteString('Buttons',tc.Name,(tc as tbutton).Caption);
        if tc is TRadioButton then
        n.WriteString('RButtons',tc.Name,(tc as tradiobutton).Caption);
        if tc is TTabSheet then
        n.WriteString('Tabs',tc.Name,(tc as TTabSheet).caption);
        if tc is TCheckBox then
        n.WriteString('CheckBoxes',tc.Name,(tc as TCheckBox).Caption);
        if tc is TGroupBox then
        n.WriteString('Groups',tc.Name,(tc as TGroupBox).Caption);

        if tc is TRadioGroup then
        n.WriteString('RGroups',tc.Name,(tc as TRadioGroup).Caption);

        if tc is TPanel and ((tc as tpanel).caption<>'') then
        n.WriteString('Panels',tc.Name,(tc as TPanel).Caption);
//        n.WriteInteger('CombosLen',tc.Name,(tc as Tcombobox).ItemIndex);
        if tc is TComboBox and (pos('sf',tc.Name)<>1)and (pos('gk',tc.Name)<>1) then begin
        for j:=0 to (tc as tcombobox).Items.Count-1 do
            n.WriteString('Combos',tc.Name+format('%.2d',[j]),(tc as tcombobox).Items.Strings[j]);

        end;

        n.UpdateFile;
        try
        if tc.ComponentCount<>0 then
        saveall(tc,n);
        except
        _('Can''t save '+tc.name);
        end;
    end;
end;

procedure loadall(c:tcomponent;n:tinifile);
var i,j,k:integer;
    tc:tcomponent;
    s:string;
begin
    try
//    _('Loading all the strings');
    //_('199='+o[199]);
    for i:=0 to c.ComponentCount-1 do begin
        tc:=c.Components[i];
        if tc is TLabel then begin
            s:=n.readstring('Labels',tc.Name,'');
            if s<>'' then (tc as tlabel).Caption:=s;
        end;

        if tc is tbutton then begin
            s:=n.readstring('Buttons',tc.Name,'');
            if s<>'' then (tc as tbutton).Caption:=s;
        end;


        if tc is tbutton then begin
            s:=n.readstring('Buttons',tc.Name,'');
            if s<>'' then (tc as tbutton).Caption:=s;
        end;
        if tc is tradiobutton then begin
            s:=n.readstring('RButtons',tc.Name,'');
            if s<>'' then (tc as tradiobutton).Caption:=s;
        end;

        if tc is TTabSheet then begin
            s:=n.readstring('Tabs',tc.Name,'');
            if s<>'' then (tc as TTabSheet).Caption:=s;
        end;
        if tc is TCheckBox then begin
            s:=n.readstring('CheckBoxes',tc.Name,'');
            if s<>'' then (tc as TCheckBox).Caption:=s;
        end;
        if tc is TGroupBox then begin
            s:=n.readstring('Groups',tc.Name,'');
            if s<>'' then (tc as TGroupBox).Caption:=s;
        end;
        if tc is TRadioGroup then begin
            s:=n.readstring('RGroups',tc.Name,'');
            if s<>'' then (tc as TRadioGroup).Caption:=s;
        end;
        if tc is TPanel then begin
            s:=n.readstring('Panels',tc.Name,'');
            if s<>'' then (tc as TPanel).Caption:=s;
        end;
        if tc is TMenuItem then begin
            s:=n.readstring('Menus',tc.Name,'');
            if s<>'' then (tc as TMenuItem).Caption:=s;
        end;

        if tc is TComboBox and (pos('sf',tc.Name)<>1) then begin
            k:=(tc as tcombobox).ItemIndex;
        for j:=0 to (tc as tcombobox).Items.Count-1 do begin
            s:=n.ReadString('Combos',tc.Name+format('%.2d',[j]),(tc as tcombobox).Items.Strings[j]);
            if s<>'' then (tc as tcombobox).Items.Strings[j]:=s;
        end;
            (tc as tcombobox).ItemIndex:=k;
        end;

    end;
    datamodule1.helpmenu.Visible:=fileexists(umcdir+o[198]);
    except
    _('Exception in loadall');

    end;
    //_('199='+o[199]);
  //  _('Strings loaded');
end;

procedure ReadTrayMenu(filename:string);
var i,j:integer;
    n:tinifile;
    s:string;
begin
    try
    //_('Reading menu from '+filename);
//    if umcsetupf<>nil then umcsetupf.Evaluator.Lines.Add('Read tray '+filename);
    if datamodule1=nil then exit;
    n:=tinifile.create(filename);
    if umcsetupf<>nil then
   // try
    for i:=0 to datamodule1.Tray.PopupMenu.Items.Count-1 do begin
        s:=n.ReadString('Menus',datamodule1.Tray.PopupMenu.Items[i].Name,'');
        if s<>'' then datamodule1.Tray.PopupMenu.Items[i].Caption:=s;

        if datamodule1.Tray.PopupMenu.Items[i].Count<>0 then
            for j:=0 to datamodule1.Tray.PopupMenu.Items[i].Count-1 do begin

                s:=n.ReadString('Menus',datamodule1.Tray.PopupMenu.Items[i].items[j].Name,'');

                if s<>'' then
                    try
                        datamodule1.Tray.PopupMenu.Items[i].items[j].Caption:=s;
                    except
                        _('Can''t assign traymenu entry ('+s+')');
                    end;

            end;
        end;
    {except
    _('Exception while reading of traymenu entries');
    end;   }

    n.Free;
    datamodule1.smenu.Caption:=o[192]+' Useless Macro Collection '+GetUMCver;
    except
    _('Exception in loadtraymenu');
    end;
//    _('Traymenu read');
end;

procedure ReadLanguageData(filename:string);
var n:tinifile;
begin
    try
  //  _('Reading language from '+filename);
    n:=tinifile.create(filename);
    try
    if umcsetupf<>nil then loadall(UMCsetupf,n);
    except
    _('Exception while trying to loadall from '+filename);
    end;
    n.Free;

 //   try
    readtraymenu(filename);
{    except
    _('Exception while trying to readtraymenu from '+filename);
    end;}
    try
    ReadStrings(filename);
    except
    _('Exception while trying to read strings');
    end;

    strSec:=o[44];
    strMin:=o[45];
    strHour:=o[46];
    strDay:=o[47];
    strMounth:=o[48];
    datamodule1.smenu.Caption:=o[192]+' Useless Macro Collection '+GetUMCver;
    except
    _('Exception in readlangdata');
    end;
//    _('Language read');
end;

procedure WriteTrayMenu(filename:string);
var i,j:integer;
    n:tinifile;
    s:string;

begin
    _('Writing menu to '+filename);
    n:=tinifile.create(filename);
    for i:=0 to datamodule1.Tray.PopupMenu.Items.Count-1 do begin
        s:=datamodule1.Tray.PopupMenu.Items[i].Caption;
        if s<>'-' then
        n.WriteString('Menus',datamodule1.Tray.PopupMenu.Items[i].Name,s);
        if datamodule1.Tray.PopupMenu.Items[i].Count<>0 then
            for j:=0 to datamodule1.Tray.PopupMenu.Items[i].Count-1 do begin
                s:=datamodule1.Tray.PopupMenu.Items[i].items[j].Caption;
                if s<>'-' then
                n.WriteString('Menus',datamodule1.Tray.PopupMenu.Items[i].items[j].Name,s);
            end;
        end;


    n.Free;
end;


procedure WriteLanguageData(filename:string);
var n:tinifile;

begin
    _('Writing langdata to '+filename);
    n:=tinifile.create(filename);
    saveall(UMCsetupf,n);
    n.Free;
    writeTrayMenu(filename);
    StoreStrings(filename);
end;

procedure StoreStrings(filename:string);
var n:tinifile;
    i:integer;
begin
    _('Writing strings to '+filename);
    n:=tinifile.create(filename);
    for i:=1 to omax do
        if o[i]<>'' then n.WriteString('Strings',inttostr(i),o[i]);
    n.Free;
end;
procedure ReadStrings(filename:string);
var n:tinifile;
    i:integer;
    s:string;
begin
//    _('Reading strings from '+filename);
    //_('199='+o[199]);
    n:=tinifile.create(filename);
    for i:=1 to omax do begin
        s:=n.readstring('Strings',inttostr(i),'');
        if s<>'' then o[i]:=s;
    end;
    n.Free;
    //_('199='+o[199]);
  //  _('Strings read');
end;
procedure RestoreStrings;
var i:integer;
begin
    _('Resetting strings');
    for i:=1 to omax do
        o[i]:='';
    o[1]:=' ';
    o[2]:=' ';
    o[3]:='   ';
    o[4]:='      ';
    o[5]:=' ';
    o[6]:='- ';
    o[7]:=' ';
    o[8]:='  ';
    o[9]:='  ';
    o[10]:='  ';
    o[11]:='   ,  ';
    o[12]:=' ';
    o[13]:=' ';
    o[14]:='  ';
    o[15]:=' ';
    o[16]:='';
    o[17]:='';
    o[18]:=' !';
    o[19]:='  !!!';
    o[20]:='    ';
    o[21]:='    ';
    o[22]:='';
    o[23]:='';
    o[24]:='';
    o[25]:='';
    o[26]:='';
    o[27]:='';
    o[28]:='  ';
    o[29]:='  ';
    o[30]:=' ';
    o[31]:='  ';
    o[32]:=' ';
    o[33]:='  ';
    o[34]:='  ';
    o[35]:='   ';
    o[36]:='   ';
    o[37]:='<>';
    o[38]:='   !';
    o[39]:='!         !';
    o[40]:='/';
    o[41]:='';
    o[42]:='';
    o[43]:='';
    o[44]:='';
    o[45]:='';
    o[46]:='';
    o[47]:='';
    o[48]:='';
    o[49]:='';
    o[50]:='';
    o[51]:='';
    o[52]:='localhost';
    o[53]:='Charset';
    o[54]:='Key';
    o[55]:='Macro';
    o[56]:='Name';
    o[57]:='Sender';
    o[58]:='Recipient';
    o[59]:='The string you specified cannot be found';
    o[60]:='Filename';
    o[61]:='Parts collected';
    o[62]:='Time stamp';
    o[63]:='Done';
    o[64]:='parts';
    o[65]:='File age, days';
    o[66]:='Mailer';
    o[67]:='Total size';
    o[68]:='Mean size';
    o[69]:='Entries';
    o[70]:='running';
    o[71]:='standby';
    o[72]:='No compression';
    o[73]:='Min. compression';
    o[74]:='Normal compression';
    o[75]:='Max. compression';
    o[76]:='By sender''s IP address';
    o[77]:='By sender''s mailserver name';
    o[78]:='By names of servers which letter trespass';
    o[79]:='Server name';
    o[80]:='';
    o[81]:='';
    o[82]:='';
    o[83]:='';
    o[84]:='';
    o[85]:='By recipient';
    o[86]:='By sender';
    o[87]:='By mailer';
    o[88]:='By charset';
    o[89]:='By words';
    o[90]:='';
    o[91]:='';
    o[92]:='';
    o[93]:='<  0>';
    o[94]:='';
    o[95]:='.';
    o[96]:='.';
    o[97]:='<    !>';
    o[98]:='<   >';
    o[99]:='IP address';
    o[100]:='  ';
    o[101]:='  ';
    o[102]:='  ';
    o[103]:='    The Bat!';
    o[104]:='    The Bat!';
    o[105]:='    The Bat!';
    o[106]:='   ';
    o[107]:='  ';
    o[108]:='   ';
    o[109]:='  ';
    o[110]:='  ';
    o[111]:='  ';
    o[112]:='  ';
    o[113]:='  ';
    o[114]:='  : ';
    o[115]:='  : ';
    o[116]:=': /';
    o[117]:=' :';
    o[118]:=' :';
    o[119]:=' The Bat!';
    o[120]:='  %s    :';
    o[121]:='Please select the directory';
    o[122]:='First 50 results are showed';
    o[123]:='First date';
    o[124]:='Last date';
    o[125]:='Per hour';
    o[126]:='Per day';
    o[127]:='Per week';
    o[128]:='Per month';
    o[129]:='Per year';
    o[130]:=' ';
    o[131]:='  ';
    o[132]:='  ';
    o[133]:='  ';
    o[134]:='Total online time';
    o[135]:='Mean length of online session';
    o[136]:='Spash is off';
    o[137]:='';
    o[138]:='Nice splash';
    o[139]:='By sender''s name';
    o[140]:='By recipients''s name';
    o[141]:='Name';
    o[142]:='By ISP''s name';
    o[143]:='No internet connection';

    o[149]:='silence';
    o[150]:='';
    o[151]:='';
    o[152]:='';
    o[153]:='WinAMP  ';
    o[154]:='stereo';
    o[155]:='mono';
    o[156]:='Foobar2000 is not active';
    o[157]:='1by1 is not active';
    o[158]:='System Tray Player is not active';
    o[159]:='Quintessential Player is not active';
    o[160]:='Apollo Player is not active';
    o[161]:='By words';
    o[162]:='By charsets';
    o[163]:='By mailer';
    o[164]:='By sender';
    o[165]:='By recipient';
    o[166]:='By keys';
    o[167]:='<for internal use only>';   //Madspam
    o[168]:='<for internal use only>'; //Madnonspam
    o[169]:='By macro';
    o[170]:='<allows you to save incoming traffic>';
    o[171]:='By IP';
    o[172]:=o[139];
    o[173]:=o[140];
    o[174]:=o[142];
    o[175]:=o[77];
    o[176]:=o[78];
    o[177]:='Special statistics';


    o[189]:='ml_eng.dat';
    o[190]:=' ,      ,   TheBat!';
    o[191]:=' ';
    o[192]:='';
    o[193]:='      ! :))    ,      ';
    o[194]:='  !';
    o[195]:='';
    o[196]:='';
    o[197]:=' ';
    o[198]:='readme.chm';
    o[199]:=' ()';
    o[200]:='(c) Stanislav V. Mikov';

end;

end.
