unit UMCmiscdata;

interface

uses
  SysUtils, Classes, CoolTrayIcon, ImgList, Controls, Menus, jclshell, windows, messages,
  ExtCtrls, forms, LrCPUUsage{, TextTrayIcon};

type
  TDataModule1 = class(TDataModule)
    //Tray: TCoolTrayIcon;
    TrayMenu: TPopupMenu;
    smenu: TMenuItem;
    N1: TMenuItem;
    Links1: TMenuItem;
    N3: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    MouseTrackingTimer: TTimer;
    online: TImageList;
    offline: TImageList;
    RAStimer: TTimer;
    HelpMenu: TMenuItem;
    UselessMacroCollectiononthebatworldde1: TMenuItem;
    Subscribetogetnewversionsbyemail1: TMenuItem;
    Separator: TMenuItem;
    UselessMacroCollectiononbatmaildevu1: TMenuItem;
    Tray: TCoolTrayIcon;
    delii: TMenuItem;
    RelatedRussianlanguagegroups1: TMenuItem;
    VirtualcityNowherecity1: TMenuItem;
    Linksconference1: TMenuItem;
    Emailconference1: TMenuItem;
    UnofficialTheBatdiscussinglist1: TMenuItem;
    StanislavMikovsonhttpstihiru1: TMenuItem;
    online2: TImageList;
    offline2: TImageList;
    Onlinehelp1: TMenuItem;
    Inrussianhttpnobatru1: TMenuItem;
    Ingerman1: TMenuItem;
    jfgfdhjdfdhfg: TMenuItem;
    Reportnewlink1: TMenuItem;
    cpuusage: TLrCPUUsage;
    jnjjj: TMenuItem;
    Sendmailtoauthor1: TMenuItem;
    SubscribeToInternationalSupportGroup1: TMenuItem;
    procedure smenuClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure MouseTrackingTimerTimer(Sender: TObject);
    procedure TrayDblClick(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure RAStimerTimer(Sender: TObject);
    procedure HelpMenuClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure UselessMacroCollectiononthebatworldde1Click(Sender: TObject);
    procedure Subscribetogetnewversionsbyemail1Click(Sender: TObject);
    procedure UselessMacroCollectiononbatmaildevu1Click(Sender: TObject);
    procedure UMCexc(Sender: TObject; E: Exception);
    procedure TrayClick(Sender: TObject);
    procedure TrayMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VirtualcityNowherecity1Click(Sender: TObject);
    procedure Linksconference1Click(Sender: TObject);
    procedure UnofficialTheBatdiscussinglist1Click(Sender: TObject);
    procedure Emailconference1Click(Sender: TObject);
    procedure StanislavMikovsonhttpstihiru1Click(Sender: TObject);
    procedure Inrussianhttpnobatru1Click(Sender: TObject);
    procedure Ingerman1Click(Sender: TObject);
    procedure Reportnewlink1Click(Sender: TObject);
    procedure Sendmailtoauthor1Click(Sender: TObject);
    procedure SubscribeToInternationalSupportGroup1Click(Sender: TObject);

  public
    once:boolean;
  end;

var
  DataModule1: TDataModule1=nil;
  mouseX,mouseY:integer;
  mouseLen:int64;
  mouseWay:double;

implementation

uses UMCsetupform, UMCaux, UMClanguages, RASinfo, UMCstatistics, UMClogger,
  UMCvar, UMCwinamp, UMCparanoia, dateutils, graphics, RASUnit;

{$R *.dfm}

procedure TDataModule1.smenuClick(Sender: TObject);
begin
//    if UMCsetupf=nil then GetStr;
  UMCsetupf.Show;

end;

procedure TDataModule1.N5Click(Sender: TObject);
begin
    ShellExecEx(rsMinisoft_sub);
end;

procedure TDataModule1.N6Click(Sender: TObject);
begin
    ShellExecEx(rsHomepage);
end;

procedure TDataModule1.MouseTrackingTimerTimer(Sender: TObject);
var x,y:integer;
begin
    if sMouseTracking then begin
    x:=mouse.CursorPos.X;
    y:=mouse.CursorPos.Y;
    inc(mouseLen,round(sqrt(abs(sqr(x-mousex)+sqr(y-mousey)))));
    mouseway:=mouseway+sqrt(abs(sqr((x-mousex)/screen.Width*mmWidth)+sqr((y-mousey)/screen.Height*mmHeight)));
    mouseX:=x;
    mouseY:=y;
    end;
    if once then begin
        umcsetupf.langlistClick(datamodule1);
        once:=false;
    end;

end;

procedure TDataModule1.TrayDblClick(Sender: TObject);
begin
    umcsetupf.Show;
end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
    _('Datamodule created');
    mousex:=mouse.CursorPos.X;
    mousey:=mouse.CursorPos.Y;
    mouselen:=0;
    mouseway:=0;
    once:=false;
end;

procedure TDataModule1.RAStimerTimer(Sender: TObject);
var AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond:word;
    z:array[0..15] of TRasConn;
    i,k:longint;
begin

    DecodeDateTime(now, AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond);
    setvar('datetime',datetimetostr(now));
    setvar('date',datetostr(now));
    setvar('time',timetostr(now));

    setvar('year',aYear);
    setvar('month',aMonth);
    setvar('day',ADay);
    setvar('hour',AHour);
    setvar('min',AMinute);
    setvar('sec',ASecond);
    setvar('cpuusage',floattostr(cpuusage.GetCPUUsage));

    setvar('weekofyear',WeekOfTheYear(now));


    setvar('dayofweek',DayOfTheWeek(now));
    setvar('dayofyear',DayOfTheYear(now));
    setvar('hourofday',HourOfTheDay(now));
    setvar('hourofmonth',HourOfTheMonth(now));
    setvar('hourofweek',HourOfTheWeek(now));
    setvar('hourofyear',HourOfTheYear(now));
    setvar('ver',getumcver);
    SetVar('umcdir',Umcdir);
    SetVar('tbdir',tbdir);

//    _('2');

    if sWAtracking then begin
//    _('3');

    if WA then setvar('wa','1') else setvar('wa','0');

    setvar('wa_ver',GetWAver);
    setvar('wa_state',GetWAstate);
    setvar('wa_tracklen',GetWAtracklen(1));
    setvar('wa_trackpos',GetWAtracklen(0));
    setvar('wa_pllen',GetWAPLlen);
    setvar('wa_plpos',GetWAPLpos);
    setvar('wa_rate',GetWArate);
    setvar('wa_brate',GetWAbitrate);
    setvar('wa_ch',GetWAch);
    setvar('wa_cht',GetWAcht);
    setvar('wa_title',GetWAtitle);

    end;

    if (ConnectedToInternet in [ctDialUp,ctProxy])and(ConnectionState=0) then begin
        ConnectionState:=1;
        InternetStamp:=now;
        case traymode of
            1:tray.IconList:=online;
            2:tray.IconList:=online2;
        end;
        bc:=0;
        i:=sizeof(z);
        z[0].dwSize:=sizeof(TRasConn);
        RasEnumConnections(@z,i,k);

        cn:=strpas(z[0].szEntryName);
        _('CONNECTION ESTABLISHED ['+cn+']');
    end;
    if (ConnectionState=1)and(ConnectedToInternet=ctNone) then begin
        case traymode of
            1:tray.IconList:=offline;
            2:tray.IconList:=offline2;
        end;
        ConnectionState:=0;
        OnlineTime:=OnlineTime+SecondsBetween(now,internetstamp);
        _('CONNECTION ENDED ['+cn+']');
        stats[madisp].sorter.storage.ix(cn,bc);
        _(inttostr(bc)+' bytes received');
        inc(osc);
     end;

end;

procedure TDataModule1.HelpMenuClick(Sender: TObject);
begin
    ShellExecEx(umcdir+o[198]);
end;

procedure TDataModule1.N3Click(Sender: TObject);
begin
    ShellExecEx(rsMailBug);
end;

procedure TDataModule1.DataModuleDestroy(Sender: TObject);
begin
    _('Datamodule destroyed');
end;

procedure TDataModule1.UselessMacroCollectiononthebatworldde1Click(
  Sender: TObject);
begin
    ShellExecEx(rsGeHomepage);
end;

procedure TDataModule1.Subscribetogetnewversionsbyemail1Click(
  Sender: TObject);
begin
    ShellExecEx(rsUMCver_sub);
end;

procedure TDataModule1.UselessMacroCollectiononbatmaildevu1Click(
  Sender: TObject);
begin
    ShellExecEx(rsGe2Homepage);
end;

procedure TDataModule1.UMCexc(Sender: TObject; E: Exception);
var fr:string;
    n:tobject;
begin
    if sender=nil then fr:='nil' else fr:=sender.ClassName;
    _('@@ Unhandled exception   :'+e.ClassName+' ('+e.Message+')');
    _('@@ Exception sender class: '+fr);
    n:=Sender;
    if (n is tcomponent) then
    _('@@ Exception sender name : '+(n as tcomponent).Name);
    _(format('@@ Address: %p',[exceptaddr]));
//    application.HookMainWindow();
    n:=ExceptObject;
    _('@@ Exception object class: '+n.ClassName);
    if (n is tcomponent) then
    _('@@ Exception object name : '+(n as tcomponent).Name);
    _;

end;

procedure TDataModule1.TrayClick(Sender: TObject);
begin
    traymenu.Popup(mouse.CursorPos.X,mouse.CursorPos.Y);

end;

procedure TDataModule1.TrayMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if button=mbright then
    traymenu.Popup(mouse.CursorPos.X,mouse.CursorPos.Y);

end;

procedure TDataModule1.VirtualcityNowherecity1Click(Sender: TObject);
begin
    ShellExecEx(rsNowhere_sub);
end;

procedure TDataModule1.Linksconference1Click(Sender: TObject);
begin
    ShellExecEx(rsLinks_sub);
end;

procedure TDataModule1.UnofficialTheBatdiscussinglist1Click(
  Sender: TObject);
begin
    ShellExecEx(rsBat_sub);
end;

procedure TDataModule1.Emailconference1Click(Sender: TObject);
begin
    ShellExecEx(rsEmail_sub);
end;

procedure TDataModule1.StanislavMikovsonhttpstihiru1Click(Sender: TObject);
begin
    ShellExecEx(rsMyPage);
end;

procedure TDataModule1.Inrussianhttpnobatru1Click(Sender: TObject);
begin
    ShellExecEx(rsHomePage);
end;

procedure TDataModule1.Ingerman1Click(Sender: TObject);
begin
    ShellExecEx(rsGermanHelp);

end;

procedure TDataModule1.Reportnewlink1Click(Sender: TObject);
begin
    ShellExecEx(rsNewLink);

end;

procedure TDataModule1.Sendmailtoauthor1Click(Sender: TObject);
begin
    ShellExecEx(rsMail);

end;

procedure TDataModule1.SubscribeToInternationalSupportGroup1Click(
  Sender: TObject);
begin
    ShellExecEx(rsIntMinisoft_sub);
end;

end.
