unit UMCwinamp;

interface
uses
{$IFNDEF UMP}
UMClanguages, UMClogger,
  mmsystem,
{$ENDIF}
sysutils,
 windows;

const waidVer=0;
      waidStatus=104;
      waidTrackLen=105;
      waidPLlen=124;
      waidPLpos=125;
      waidInfo=126;
      waidEQ=127;
      waidSkinDir=201;

//Winamp functions
function GetWAdata(ID:integer;data:integer=0):integer;
function GetWAver:string;
function GetWAstate(p:string='';ps:string='';st:string=''):string;
function GetWAtracklen(data:integer=0):string;
function GetWAPLlen:string;
function GetWAPLpos:string;
function GetWArate:string;
function GetWAbitrate:string;
function GetWAch:string;
function GetWAcht:string;
function WA:boolean;


function np(s:string=''):string;
function STP:boolean;
function ap:boolean;
function QCD:boolean;
function GetWAtitle:string;
function GetEq(height:integer=9):string;
function STPnp:string;
function QCDnp:string;
function apnp:string;
function QCDtime:string;
function QCDtrack:string;

//Foobar functions
function GetFBtitle:string;
function FB:boolean;

//1by1 functions
function Get1by1title:string;
function _1by1:boolean;
function Get1by1time:string;

implementation
uses strutils;
function np(s:string=''):string;
begin
        result:='';
        if qcd then result:=qcdnp
        else
        if ap then result:=apnp
        else
        if wa then result:=getwatitle
        else
        if fb then result:=getfbtitle
        else
        if _1by1 then result:=get1by1title
        else
        if stp then result:=stpnp
        ;
        if result='' then result:=s;
end;

function GetEq(height:integer=9):string;
var eq:array[0..10]of integer;
    i,j:integer;
    s:string;
    papos:integer;
    c:integer;
const chs='$Ss.';
begin
    result:='';
    if not WA then exit;
    if height=0 then height:=9;
    if height<3 then height:=3;
    if height>65 then height:=65;
    for i:=0 to 10 do
        eq[i]:=GetWAdata(waidEQ,i);
    papos:=round(eq[10]/63*height);

    for j:=0 to height-1 do begin
        s:='';
        for i:=0 to 9 do begin
            if j=round(eq[i]/63*(height-1)) then begin
                c:=1+abs(round((j/(height-1)*63-eq[i])*length(chs)));
                if c<1 then c:=1;
                if c>length(chs) then c:=length(chs);
                s:=s+chs[c];
            end else
            if round(j/(height-1)*63)>eq[i] then s:=s+chs[1]
            else if round(j/(height-1)*63)<eq[i] then begin
                if j=papos then s:=s+'=' else s:=s+' '
            end;
        end;
        result:=result+s+#13#10;
    end;
end;
function GetWAtitle:string;
var hwndWinamp : THandle;
    str:pchar;
    i:integer;
begin
{$IFNDEF UMP}
    result:=o[153];
{$ELSE}
    result:='Winamp is not active';
{$ENDIF}
    if not WA then exit;
    getmem(str,2048);
    hwndWinamp := FindWindow('Winamp v1.x', nil);
    GetWindowText(hwndWinamp,str,2048);
    result:=string(str);
    freemem(str);

    result:=trim(copy(result,1,pos('- Winamp',result)-1));
    i:=pos('. ',result);
    if i<>0 then result:=copy(result,i+2,length(result)-1);


end;
function GetFBtitle:string;
var hwndWinamp : THandle;
    str:pchar;
//    i:integer;
begin
{$IFNDEF UMP}
    result:=o[156];
{$ELSE}
    result:='FooBar is not active';
{$ENDIF}
    if not FB then exit;
    getmem(str,2048);
    hwndWinamp := FindWindow('FOOBAR2000_CLASS', nil);
    if hwndwinamp=0 then hwndWinamp := FindWindow('{DA7CD0DE-1602-45e6-89A1-C2CA151E008E}', nil);
    GetWindowText(hwndWinamp,str,2048);
    result:=string(str);
    freemem(str);

    result:=trim(copy(result,1,pos('[foobar',result)-1));
{    i:=pos('. ',result);
    if i<>0 then result:=copy(result,i+2,length(result)-1);}


end;
function STP:boolean;
begin
    result:=(FindWindow('STPAppClass', nil)<>0);
end;
function QCD:boolean;
begin
    result:=(FindWindow('PlayerCanvas', nil)<>0);
end;
function ap:boolean;
begin
    result:=(FindWindow('Apollo - Main Window', nil)<>0);
end;

function QCDnp:string;
var hwnd : THandle;
    str:pchar;
    i:integer;
begin
{$IFNDEF UMP}
    result:=o[159];
{$ELSE}
    result:='Quintessential Player is not active';
{$ENDIF}
    if not qcd then exit;
    getmem(str,2048);
    hwnd := FindWindow('PlayerCanvas', nil);
    GetWindowText(hwnd,str,2048);
    result:=string(str);
    freemem(str);
    i:=pos(']',result);
    result:=copy(result,i+2,length(result));
//    result:=copy(result,6,length(result)-5);
end;
function QCDtime:string;
var hwnd : THandle;
    str:pchar;
    i:integer;
begin
    result:='';
    if not qcd then exit;
    getmem(str,2048);
    hwnd := FindWindow('PlayerCanvas', nil);
    GetWindowText(hwnd,str,2048);
    result:=string(str);
    freemem(str);
    i:=pos('[',result);
    result:=copy(result,i+1,length(result));
    i:=pos(' ',result);
    result:=copy(result,i+1,length(result));
    i:=pos(']',result);
    result:=copy(result,1,i-1);
//    result:=copy(result,6,length(result)-5);
end;
function QCDtrack:string;
var hwnd : THandle;
    str:pchar;
    i:integer;
begin
    result:='';
    if not qcd then exit;
    getmem(str,2048);
    hwnd := FindWindow('PlayerCanvas', nil);
    GetWindowText(hwnd,str,2048);
    result:=string(str);
    freemem(str);
    i:=pos('[',result);
    result:=copy(result,i+1,length(result));
    i:=pos(' ',result);
    result:=copy(result,1,i);
//    result:=copy(result,6,length(result)-5);
end;
function STPnp:string;
var hwnd : THandle;
    str:pchar;
   // i:integer;
begin
{$IFNDEF UMP}
    result:=o[158];
{$ELSE}
    result:='System Tray Player is not active';
{$ENDIF}
    if not stp then exit;
    getmem(str,2048);
    hwnd := FindWindow('STPAppClass', nil);
    GetWindowText(hwnd,str,2048);
    result:=string(str);
    freemem(str);
    result:=copy(result,6,length(result)-5);
end;
function apnp:string;
{var hwnd : THandle;
    str:pchar;
    i:integer; }
begin
{$IFNDEF UMP}
    result:=o[160];
{$ELSE}
    result:='Apollo Player is not active';
{$ENDIF}
    if not ap then exit;
    result:=getwatitle;

    {getmem(str,2048);
    hwnd := FindWindow('Apollo - Main Window', nil);
    GetWindowText(hwnd,str,2048);
    result:=string(str);
    freemem(str);
    i:=pos(' ',result);
    result:=copy(result,i+1,length(result));}

end;

function Get1by1title:string;
var hwndWinamp : THandle;
    str:pchar;
    i:integer;
begin
{$IFNDEF UMP}
    result:=o[157];
{$ELSE}
    result:='1by1 is not active';
{$ENDIF}
    if not _1by1 then exit;
    getmem(str,2048);
    hwndWinamp := FindWindow('1by1WndClass', nil);
    GetWindowText(hwndWinamp,str,2048);
    result:=string(str);
    freemem(str);

    i:=pos(' ',result);
    result:=copy(result,i+1,length(result)-i);
    if result='- The Directory Player' then result:='';
//    result:=trim(copy(result,1,pos('[foobar',result)-1));
{    i:=pos('. ',result);
    if i<>0 then result:=copy(result,i+2,length(result)-1);}


end;

function Get1by1time:string;
var hwndWinamp : THandle;
    str:pchar;
    i:integer;
begin
    result:='';
    if not _1by1 then exit;
    getmem(str,2048);
    hwndWinamp := FindWindow('1by1WndClass', nil);
    GetWindowText(hwndWinamp,str,2048);
    result:=string(str);
    freemem(str);

    i:=pos(' ',result);
    result:=copy(result,1,i-1);
    if result='1by1' then result:='0''00';
    result:=AnsiReplaceStr(result,'''',':');

end;

function GetWArate:string;
begin
    result:='';
    if not WA then exit;
    result:=inttostr(GetWAdata(waidInfo,0));
end;
function GetWAbitrate:string;
begin
    result:='';
    if not WA then exit;
    result:=inttostr(GetWAdata(waidInfo,1));
end;
function GetWAch:string;
begin
    result:='';
    if not WA then exit;
    result:=inttostr(GetWAdata(waidInfo,2));
end;
function GetWAcht:string;
begin
    result:='';
    if not WA then exit;
{$IFNDEF UMP}
    if GetWAdata(waidInfo,2)=2 then result:=o[154] else result:=o[155];
{$ELSE}
    if GetWAdata(waidInfo,2)=2 then result:='Stereo' else result:='Mono';
{$ENDIF}
end;

function GetWAPLlen:string;
begin
    result:='';
    if not WA then exit;
    result:=inttostr(GetWAdata(waidPLlen));
end;
function GetWAPLpos:string;
begin
    result:='';
    if not WA then exit;
    result:=inttostr(GetWAdata(waidPLpos)+1);
end;
function GetWAtracklen(data:integer=0):string;
var ms,n:integer;

begin
    result:='';
    if not WA then exit;
    n:=GetWAdata(waidTrackLen,data);
    ms:=(n mod 1000)div 10;
    if data=0 then
    n:=n div 1000;
    if data=0 then
    result:=format('%d:%.2d.%.2d',[n div 60,n mod 60,ms])
    else
    result:=format('%d:%.2d',[n div 60,n mod 60])
end;
function GetWAstate(p:string='';ps:string='';st:string=''):string;
begin
    result:='';
    if not WA then exit;
{$IFNDEF UMP}
    if p='' then p:=o[150];
    if ps='' then ps:=o[151];
    if st='' then st:=o[152];
{$ELSE}
    if p='' then p:='Playing';
    if ps='' then ps:='Paused';
    if st='' then st:='Stopped';
{$ENDIF}
    case GetWAdata(waidStatus) of
        1:result:=p;
        3:result:=ps;
    else
        result:=st;
    end;

end;


function FB:boolean;
begin
    result:=(FindWindow('FOOBAR2000_CLASS', nil)<>0)or(FindWindow('{DA7CD0DE-1602-45e6-89A1-C2CA151E008E}', nil)<>0);
end;
function WA:boolean;
begin
    result:=FindWindow('Winamp v1.x', nil)<>0;
end;
function _1by1:boolean;
begin
    result:=FindWindow('1by1WndClass', nil)<>0;
end;
function GetWAver:string;
var s:string;
    i:integer;
begin
    result:='';
    if not WA then exit;
    i:=GetWADAta(waidVer);
    s:=format('%x',[i]);
    result:=s[1]+'.'+s[2]+s[4];
end;
function GetWAdata(ID:integer;data:integer=0):integer;
var hwndWinamp : THandle;
begin
    hwndWinamp := FindWindow('Winamp v1.x', nil);
    result:=SendMessage(hwndWinamp,1024, data, id);

end;


end.
