library UniNP;

uses
  SysUtils,
//  Classes,messages,
  UMCwinamp in 'UMCwinamp.pas';
{$E TBP}


{$R *.res}

const PackName='Universal NP';

    UMP_macrolist=
    'UNPVER'#13#10+
    'NP'#13#10+
    'NPIF'#13#10;

{$i ump.inc}

function _gs(Params: ITBPDataProvider;strno:integer):string;
var p:pchar;
    size:integer;
    s:string;
begin
    size:=params.GetDataByID(strno,nil,-1);
    getmem(p,size);
    params.GetDataByID(strno,p,size);
    s:=copy(p,1,size);
    freemem(p);
    result:=s;
end;


function TBP_ExecMacro(AMacro: Pointer; MaxLen: Integer; Template, Params: ITBPDataProvider): Integer; stdcall;
var CurrentMacro,ResultString:string;
    i,t:integer;
    b:pchar;

begin
    SetString(CurrentMacro, PChar(AMacro), MaxLen);
    CurrentMacro:=UpperCase(CurrentMacro);
    result:=123257;
    ResultString:='Bad result '+currentmacro;
    if CurrentMacro='UNPVER' then
      ResultString:='Universal NP ver.'+ver;

    if CurrentMacro='NP' then
    begin
        ResultString:=np(_gs(params,0));
    end;
    if CurrentMacro='NPIF' then
    begin         
        if np='' then i:=1 else i:=0;
        t:=params.GetDataByID(i,nil,-1);
        getmem(b,t);
        params.GetDataByID(i,b,t);
        ResultString:=copy(b,1,t);
    end;

    Template.SetDataByID(Result, PChar(ResultString), Length(ResultString));
end;

exports TBP_NeedConfig, TBP_GetStatus, TBP_GetVersion, TBP_GetName,
  TBP_Finalize, TBP_Initialize, {TBP_Setup,} TBP_NeedCOM,
  TBP_GetMacroList, TBP_ExecMacro, TBP_GetInfo;

begin
end.
