unit umcsplashform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  Tumcsplash = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    verlabel: TLabel;
    Timer1: TTimer;
    Shape5: TShape;
    UMCstate: TLabel;
    Label5: TLabel;
    Shape6: TShape;
    Label6: TLabel;
    loginfo: TLabel;
    Shape7: TShape;
    procedure FormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  umcsplash: Tumcsplash=nil;

implementation

uses UMClogger, UMCaux;

{$R *.dfm}

procedure Tumcsplash.FormClick(Sender: TObject);
begin
    self.Close;
end;

procedure Tumcsplash.FormCreate(Sender: TObject);
begin
    verlabel.Caption:=GetUMCver+mode;
    timer1.Enabled:=true;
    _('Splash screen showed');
end;

procedure Tumcsplash.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    _('Splash screen closed');
end;

procedure Tumcsplash.Timer1Timer(Sender: TObject);
begin
    loginfo.Caption:=__last_log_str;
end;

procedure Tumcsplash.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    self.Close;

end;

procedure Tumcsplash.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    self.Close;

end;

procedure Tumcsplash.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
    self.Close;

end;

initialization

end.
