unit umcvieweru;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UMC_z, Menus, StdCtrls, umcparanoia, Grids;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Export1: TMenuItem;
    Exit1: TMenuItem;
    od: TOpenDialog;
    lb: TListBox;
    StatGrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure sc;
  //  procedure _(s:String);
    procedure sh;
  private
    s:string;
  public
    n:TParaDaemonSorter;
    { Public declarations }
  end;

const maxstr=200;
var
  Form1: TForm1;
  //o:array[1..maxstr]of string;

implementation

uses dateutils, umclogger, umcautoexec, UMClanguages, umcaux;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
//var i:integer;
begin
    n:=nil;
    s:='';
    sc;
    lb.Items.Clear;
//    for i:=1 to maxstr do o[i]:='Str'+inttostr(i);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
    application.Terminate;
end;

procedure TForm1.Open1Click(Sender: TObject);
const CustomDateFormat='DD/MM/YY hh:nn:ss';
var i,j,k,t,tun:integer;
    mpl:real;

begin

    tun:=1; //per day

    if od.Execute then begin
        if n<>nil then n.free;
        n:=TParaDaemonSorter.Create(true);
        n.no:=madcounter;
        n.storage:=TZStorage.create;
        _('Loading from '+od.FileName);
        n.storage.Load(od.FileName);
//        n.storage.
        n.Execute;
        s:=od.FileName;
        lb.Items.Clear;
        sh;

        k:=n.storage.cnt;
        statgrid.RowCount:=k+2;
        statgrid.FixedRows:=1;

        statgrid.Cells[1,0]:=o[67];
        statgrid.Cells[2,0]:=o[69];
        statgrid.Cells[3,0]:=o[68];
        statgrid.Cells[4,0]:=o[125];
        statgrid.Cells[5,0]:=o[123];
        statgrid.Cells[6,0]:=o[124];

    StatGrid.Canvas.Font:=StatGrid.Font;
    StatGrid.DefaultRowHeight:=StatGrid.Canvas.TextHeight('UMC by Stanislav Mikov')+4;
    for j:=0 to 6 do statgrid.Cells[j,1]:='';

    for i:=1 to k do try begin
        statgrid.Cells[0,i]:=n.storage.dataS(i-1);
        if statgrid.Cells[0,i]='unknown' then statgrid.Cells[0,i]:=o[37];

            statgrid.Cells[1,i]:=format('%.2f K',[n.storage.dataSize(i-1)/1024]);
//            BytesToString(n.storage.dataSize(i-1),stbKind,true);
            statgrid.Cells[2,i]:=inttostr(n.storage.dataV(i-1));

            if n.storage.dataV(i-1)<>0 then
                statgrid.Cells[3,i]:=//BytesToString(
                format('%.2f K',[n.storage.dataSize(i-1)/n.storage.dataV(i-1)/1024])
                //round(n.storage.dataSize(i-1)/n.storage.dataV(i-1))
                //,stbKind,true)
            else statgrid.Cells[3,i]:=o[40];
            t:=secondsbetween(n.storage.dataStamp(i-1),n.storage.dataStamp2(i-1));
            if (t=0)or(n.storage.dataV(i-1)<=2) then statgrid.Cells[4,i]:=o[40]
            else begin
            case tun of
                0:mpl:=60*60;
                1:mpl:=60*60*24;
                2:mpl:=60*60*24*7;
                3:mpl:=60*60*24*30;
                4:mpl:=60*60*24*365;
                else mpl:=0;
            end;
            if t<mpl/4 then statgrid.Cells[4,i]:=o[40] else begin
            t:=round(n.storage.dataSize(i-1)/t*mpl);
            statgrid.Cells[4,i]:=
            format('%.2f K/day',[t/1024])

//            BytesToString(t,stbKind,true);
            end;
        end;

            statgrid.Cells[5,i]:=FormatDateTime(CustomDateFormat,n.storage.dataStamp(i-1));
            statgrid.Cells[6,i]:=FormatDateTime(CustomDateFormat,n.storage.dataStamp2(i-1));

    end;
    except
    _('Error');
    end;

    end;
    sc;
end;

procedure TForm1.sc;
begin
    caption:='UMC statistics viewer ['+s+']';
end;

{procedure TForm1._(s: String);
begin
    lb.Items.Add(s);
end;}

procedure TForm1.sh;
var i,j:integer;
begin
    lb.Items.BeginUpdate;
    lb.Items.Clear;
    if n<>nil then begin
        i:=n.storage.cnt;
        _('Total entries: '+inttostr(i));
        try
        for j:=1 to i-1 do
            _(format('%80s',[n.storage.datas(i)]));
        except

        end;


    end;
    lb.Items.EndUpdate;
end;

initialization
    DoUMCAutoExec;
    UseLogging:=true;
    _('test');

end.
