unit verinfo;

interface
uses reinit, types, forms, windows, sysutils, JclFileUtils;

const
    rsBuild='build';
    rsVersion='';
    tempver='0.7';
    tempbuild='experimental';

var
  ver_:string;
  ver_info:string;
  ver_build:string;
  over_:string;
  over_info:string;
  over_build:string;
  jaws_:string;
  jaws_info:string;
  jaws_build:string;


procedure GetVerInfo(s:string;var ver_,ver_info,ver_build:string;path:string='');

implementation
var
//  S: string;
  n, Len: DWORD;
  Buf: PChar;
  Value: PChar;
  p1,p2,p3:integer;

procedure GetVerInfo(s:string;var ver_,ver_info,ver_build:string;path:string='');
begin

    ver_info:='beta build';
    ver_build:='0';
//  S := ;
  n := GetFileVersionInfoSize(PChar(S), n);
  if n > 0 then
  begin
    if path<>'' then path:=pathaddseparator(path);

    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(path+S), 0, n, Buf);
    if VerQueryValue(Buf, PChar('StringFileInfo\041904E3\FileVersion'), Pointer(Value), Len) then begin
        p1:=pos('.',value);
        p2:=p1+pos('.',copy(value,p1+1,length(value)-p1));
        p3:=p2+pos('.',copy(value,p2+1,length(value)-p2));
        ver_:=copy(value,1,p2-1);
        ver_info:=rsVersion+' '+ver_+' '+rsBuild+' '+copy(value,p3+1,length(value)-p3);
        ver_build:=copy(value,p3+1,length(value)-p3);
        end
    else ver_info:='unknown version';
    FreeMem(Buf, n);
    if trim(ver_)='' then ver_:=tempver;
    if trim(ver_build)='' then ver_build:=tempbuild;
  end;

end;
initialization
    GetVerInfo('useless.tbp',ver_,ver_info,ver_build);
    GetVerInfo('omc.bav',over_,over_info,over_build);
    GetVerInfo('e:/delphi6/projects/useless regexp jaws/jaws.tbp',jaws_,jaws_info,jaws_build);
end.
